VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "AboutClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'Variables to hold property values
Private mvarAboutTitle As String 'local copy
Private mvarAboutVersion As String 'local copy
Private mvarAboutCompanyName As String 'local copy
Private mvarAboutCopyright As String 'local copy
Private mvarAboutTradeMark As String 'local copy
Private mvarAboutUserName As String 'local copy
Private mvarAboutUserCompany As String 'local copy

Public Property Let AboutUserCompany(ByVal vData As String)

    mvarAboutUserCompany = vData
    
End Property


Public Property Get AboutUserCompany() As String

    AboutUserCompany = mvarAboutUserCompany
    
End Property



Public Property Let AboutUserName(ByVal vData As String)

    mvarAboutUserName = vData
    
End Property


Public Property Get AboutUserName() As String

    AboutUserName = mvarAboutUserName
    
End Property



Public Property Let AboutTradeMark(ByVal vData As String)
Attribute AboutTradeMark.VB_Description = "Gets or Sets the Programs Trade mark"

    mvarAboutTradeMark = vData
    
End Property


Public Property Get AboutTradeMark() As String

    AboutTradeMark = mvarAboutTradeMark
    
End Property



Public Property Let AboutCopyright(ByVal vData As String)

    mvarAboutCopyright = vData
    
End Property


Public Property Get AboutCopyright() As String

    AboutCopyright = mvarAboutCopyright
    
End Property



Public Property Let AboutCompanyName(ByVal vData As String)
Attribute AboutCompanyName.VB_Description = "Gets or Sets the programs company name"

    mvarAboutCompanyName = vData
    
End Property


Public Property Get AboutCompanyName() As String

    AboutCompanyName = mvarAboutCompanyName
    
End Property



Public Property Let AboutVersion(ByVal vData As String)

    mvarAboutVersion = vData
    
End Property


Public Property Get AboutVersion() As String

    AboutVersion = mvarAboutVersion
    
End Property



Public Property Let AboutTitle(ByVal vData As String)

    mvarAboutTitle = vData
    
End Property


Public Property Get AboutTitle() As String

    AboutTitle = mvarAboutTitle
    
End Property

'**********************************************************
'*
'*                  ABOUT CLASS INITIALIZATION
'*
'*  Retieves project information to be displayed in an
'*  About form.
'*
'*  1998 Rudy Lund
'**********************************************************
Private Sub Class_Initialize()

    Dim NameBuff As String, DataBuffer As String
    Dim lDataBufferSize As Long, hKey As Long, phkResult As Long
    Dim RetVal As Long, Value As String, RegEnumIndex As Long
    
    'Get user name and user company name from registry
    DataBuffer = Space(255)
    lDataBufferSize = Len(DataBuffer)
    NameBuff = ".Default\Software\Microsoft\MS Setup (ACME)\User Info"
    hKey = HKEY_USERS
    RetVal = RegOpenKeyEx(hKey, NameBuff, 0, KEY_ALL_ACCESS, phkResult)
    If RetVal = ERROR_SUCCESS Then
       Value = "DefCompany"
       RetVal = RegQueryValueEx(phkResult, Value, 0, 0, DataBuffer, lDataBufferSize)
       If RetVal = ERROR_SUCCESS Then
          AboutUserCompany = Left(DataBuffer, lDataBufferSize - 1)
       Else
          AboutUserCompany = "Unknown Company Name"
       End If
       Value = "DefName"
       RetVal = RegQueryValueEx(phkResult, Value, 0, 0, DataBuffer, lDataBufferSize)
       If RetVal = ERROR_SUCCESS Then
          AboutUserName = "This Product Licensed to " & Left(DataBuffer, lDataBufferSize - 1)
       Else
          AboutUserName = "Unknown User Name"
       End If
    End If
        
    'Close the Registyer Keys to avoid an error.
    RegCloseKey hKey
    RegCloseKey phkResult
    
    'Get info from project
    AboutVersion = "Version " & App.Major & "." & App.Minor
    AboutTitle = App.Title
    AboutCompanyName = App.CompanyName
    AboutCopyright = App.LegalCopyright
    AboutTradeMark = App.LegalTrademarks
 
End Sub
