VERSION 5.00
Begin VB.Form MainFrm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Time"
   ClientHeight    =   2070
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4245
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   138
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   283
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture2 
      Height          =   375
      Left            =   3120
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   1
      Top             =   1440
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.PictureBox Picture1 
      Height          =   375
      Left            =   720
      ScaleHeight     =   315
      ScaleWidth      =   2595
      TabIndex        =   0
      Top             =   720
      Width           =   2655
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   1800
      Top             =   240
   End
   Begin VB.Image Image2 
      Height          =   375
      Index           =   0
      Left            =   240
      Top             =   1440
      Visible         =   0   'False
      Width           =   735
   End
   Begin VB.Image Image1 
      Height          =   375
      Index           =   0
      Left            =   720
      Top             =   240
      Width           =   615
   End
End
Attribute VB_Name = "MainFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub Form_Load()
    'Picture1: for Progress Bar
    'Picture2: for drawing digits
    'Image2: holds digits
    'Image1: where LEDs are displayed
    InitObjects 'make sure properties are properly set before drawing
    Timer1.Enabled = False 'turn off timer
    DrawDigit_09 Picture2, Image2 'draw digits, including colon and dot
    LoadLed Image1, Image2
    ResetLed Image1, Image2
    Timer1.Enabled = True
End Sub
Private Sub LoadLed(Led As Object, SrcDigit As Object)
    'This Sub is to lay out time LED: hh:mm:ss
    'Total 6 LEDs and 2 colons
    Dim i As Integer
    
    Led(0).Width = SrcDigit(0).Width
    For i = 1 To 7
        Load Led(i)
        
        Led(i).Visible = True
        
        If i = 3 Or i = 6 Then
            Led(i).Left = Led(i - 1).Left + SrcDigit(10).Width
        Else
            Led(i).Left = Led(i - 1).Left + Led(i - 1).Width
        End If
    Next
End Sub
Sub ResetLed(Led As Object, SrcDigit As Object)
    'useful for changing color of LED during runtime
    Dim i As Integer
    
    For i = 0 To 7
        If i = 2 Or i = 5 Then
            Led(i).Picture = SrcDigit(10).Picture 'colon
        Else
            Led(i).Picture = SrcDigit(0).Picture  '0
        End If
    Next
End Sub
Private Sub Timer1_Timer()
    'for demo: current time
    DisplayDigits Image1, Image2, 0, 0, 2, Hour(Now)
    DisplayDigits Image1, Image2, 3, 0, 2, Minute(Now)
    DisplayDigits Image1, Image2, 6, 0, 2, Second(Now)
    DrawProgressBar Picture1, Second(Now), 60
End Sub
Private Sub InitObjects()
    'This sub is to initialize properties of objects to ensure it works properly
    'you can set these properties at design time
    
    'Main form
    Me.ScaleMode = 3 'pixel
    
    'picture2: used to draw images
    Picture2.ScaleMode = 3 'pixel
    Picture2.AutoRedraw = True
    Picture2.BorderStyle = 0 'none
    Picture2.BackColor = &H0& 'black
    Picture2.ForeColor = &H8000& 'for LED color
    'Set LED size
    Picture2.Width = 18
    Picture2.Height = 20
    
    'picture1: for Progress Bar
    Picture1.ScaleMode = 3 'pixel
    Picture1.AutoRedraw = True
    Picture1.ForeColor = &HC00000
    Picture1.Height = 10
    Picture1.Width = 200
    
    'Timer1
    Timer1.Interval = 100
    Timer1.Enabled = False
End Sub
