VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Tiled Form!"
   ClientHeight    =   4140
   ClientLeft      =   1440
   ClientTop       =   1605
   ClientWidth     =   6690
   Height          =   4545
   Left            =   1380
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   0
   ScaleWidth      =   0
   Top             =   1260
   Width           =   6810
   Begin VB.CommandButton Command1 
      Caption         =   "&About"
      Height          =   255
      Index           =   1
      Left            =   1050
      TabIndex        =   2
      Top             =   60
      Width           =   975
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Done"
      Height          =   255
      Index           =   0
      Left            =   75
      TabIndex        =   1
      Top             =   60
      Width           =   975
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   480
      Left            =   0
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   376.471
      ScaleMode       =   0  'User
      ScaleWidth      =   376.471
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   480
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Const SRCCOPY = &HCC0020

#If Win16 Then
Private Declare Function BitBlt% Lib "GDI" (ByVal hDestDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal xSrc As Integer, ByVal ySrc As Integer, ByVal dwRop As Long)
#ElseIf Win32 Then
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
#End If


Sub Tile(Pic As Control, Frm As Form)

'*************************************************************
' SUB NAME: Tile
'   by someone on usenet. Modified into a Subroutine by Justin Law
'
'HISTORY:
'   written in Visual Basic 3.0 on 1/28/96
'   rewritten in VB4 on 7/1/96
'
' PURPOSE:
'   tile a picture on a form
'
' INPUT:
'   Pic = Picture control name, or any type of control(gifbox) with a hDC
'   Frm = The form's name
'
' External APIs:
'   bitblt
'
' Constants:
'   SRCCOPY
'
' NOTE: The picture and form's "ClipControls"
'   properties must be set to "True". Procedure must be called
'   in the form's "Paint" event.
'
'*************************************************************

Dim SaveScaleMode As Integer
Dim width%, Height%, y%, x%, ReturnVal%

Pic.AutoRedraw = True
Pic.BorderStyle = 0
Frm.AutoRedraw = False

SaveScaleMode = Frm.ScaleMode
Frm.ScaleMode = 3

width% = Pic.width
Height% = Pic.Height
For y = 0 To Frm.ScaleHeight Step Height%
    For x = 0 To Frm.ScaleWidth Step width%
        ReturnVal% = BitBlt(Frm.hDC, x, y, width%, Height%, Pic.hDC, 0, 0, SRCCOPY&)
    Next x
Next y

Frm.ScaleMode = SaveScaleMode
End Sub


Private Sub Command1_Click(Index As Integer)
Select Case Index
    Case 0
        End
    Case 1
        MsgBox "This demo shows you how to tile a form." & vbCrLf & "Try resizing the form and see what happens."
End Select
End Sub


Private Sub Form_Load()
    App.Title = "Tiled Form!"
End Sub

Private Sub Form_Paint()
    Tile Picture1, Me
End Sub


Private Sub Form_Resize()
   
End Sub


