VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "StretchBlt Demo"
   ClientHeight    =   4620
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3570
   LinkTopic       =   "Form1"
   ScaleHeight     =   4620
   ScaleWidth      =   3570
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox PicDest2 
      Height          =   1215
      Left            =   2520
      ScaleHeight     =   77
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   61
      TabIndex        =   3
      Top             =   120
      Width           =   975
   End
   Begin VB.CommandButton Command1 
      Caption         =   "StretchBlt"
      Height          =   375
      Left            =   2520
      TabIndex        =   2
      Top             =   2880
      Width           =   975
   End
   Begin VB.PictureBox PicDest 
      Height          =   1215
      Left            =   2520
      ScaleHeight     =   77
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   61
      TabIndex        =   1
      Top             =   1440
      Width           =   975
   End
   Begin VB.PictureBox PicSource 
      AutoRedraw      =   -1  'True
      Height          =   3135
      Left            =   120
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   205
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   146
      TabIndex        =   0
      Top             =   120
      Width           =   2250
   End
   Begin VB.Label Label1 
      Caption         =   $"Form1.frx":5CA3
      ForeColor       =   &H000000FF&
      Height          =   975
      Left            =   120
      TabIndex        =   4
      Top             =   3480
      Width           =   3375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'btn_clicked is a flag to test if the command
'button has been clicked.
Dim btn_clicked As Boolean
Private Sub Command1_Click()
'Dest_hDC and Dest_hDC2 are handles to
'Device contexts for the picture box controls
Dim Dest_hDC As Long, Dest_hDC2 As Long
Dim Src_hDC As Long
Dim StretchBit As Long

Dest_hDC = PicDest.hdc
Dest_hDC2 = PicDest2.hdc
Src_hDC = PicSource.hdc

'Do this so if the use resizes the window
'it doesn't mess up the picture.
PicSource.AutoRedraw = True

'Set the scalemodes for all the picture boxes
PicSource.ScaleMode = 3 'pixel
PicDest.ScaleMode = 3 'pixel
PicDest2.ScaleMode = 3 'pixel

'Set the picDest Stretch mode. This will remove
'the eliminated lines
Call SetStretchBltMode(Dest_hDC, STRETCH_DELETESCANS)
'Stretch the image in picSource to PicDest
StretchBit = StretchBlt(Dest_hDC, 0, 0, PicDest.ScaleWidth, PicDest.ScaleHeight, Src_hDC, 0, 0, PicSource.ScaleWidth, PicSource.ScaleHeight, SRCCOPY)
'Stretch the image in picSource to PicDest2
StretchBit = StretchBlt(Dest_hDC2, 0, 0, PicDest2.ScaleWidth, PicDest2.ScaleHeight, Src_hDC, 0, 0, PicSource.ScaleWidth, PicSource.ScaleHeight, SRCCOPY)

'Since the PicSource.AutoRedraw = true we
'will refresh that image. This prevents it
'from screwing up.
PicSource.Refresh

'We will now set the AutoRedraw for PicDest
'and PicDest2. The reason we dont do this
'Durring design time is because it will not
'allow the stretched image into the picturebox.
'Since we do it after we already stretch the
'image then its ok. This is done so if the user
'resizes the window over the picturebox controls
'it will not mess up the image.

PicDest.AutoRedraw = True
PicDest2.AutoRedraw = True

'This following  block of code is there
'because of the redraw purposes. The first
'time you run this sub the picture boxes
'screw up when you resize the window over them.
'This means you have to click the button twice
'for the redraw to be fully effective. Instead
'of making the user do that, just simply write
'a little if then to have the procedure call
'call itself (Command1_Click)
If btn_clicked = False Then
    btn_clicked = True
    Command1_Click
End If
End Sub

Private Sub Form_Load()
'When the form is loaded the command button hasn't
'been clicked so set this flag to false
btn_clicked = False
End Sub
