VERSION 2.00
Begin Form frmModelGrid 
   Caption         =   "editable grid"
   ClientHeight    =   4020
   ClientLeft      =   1110
   ClientTop       =   570
   ClientWidth     =   7050
   Height          =   4425
   Left            =   1050
   LinkTopic       =   "Form1"
   ScaleHeight     =   4020
   ScaleWidth      =   7050
   Top             =   225
   Width           =   7170
   Begin Grid Grid1 
      BackColor       =   &H0080FFFF&
      Cols            =   6
      Height          =   2415
      HighLight       =   0   'False
      Left            =   480
      Rows            =   6
      TabIndex        =   0
      Top             =   1200
      Width           =   5295
   End
   Begin TextBox txtGridBox 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      ForeColor       =   &H00000000&
      Height          =   495
      Left            =   3120
      TabIndex        =   1
      Top             =   1800
      Visible         =   0   'False
      Width           =   1215
   End
End
Option Explicit

Dim oldrow As Integer, oldcol As Integer
Dim cliptext As String

Sub Form_Load ()
    grid1.Row = grid1.FixedRows
    grid1.Col = grid1.FixedCols
End Sub

Sub Grid1_Click ()
' 1 create text box, name it txtGridBox
'   set txtGridBox.borderstyle = 0
'   set txtGridBox.visible = false
'   set txtGridBox.text =
' 2 create grid, name it
'   use edit|replace all and rename grid1. to yourgridname.
' 3 copy ShowTextBox and GridCellUpdated to your form
' 4 Declare oldrow and oldcol as integers in form declarations
' 5 Declare cliptext as string in form declarations
' 6 change txtGridBox.forecolor and backcolor for better effect
' 7 change grid1.highlight property to false
' 8 copy the two lines of code from the your form_load
' 9 add code to GridCellUpdated if you want to execute some
'   of your own code when they press enter to go to the next column
' 10 if you want to restrict values entered into a cell see notes in
'   grid1_keypress and txtGridBox_keypress
'   developed by RobKraft@aol.com 3/1/95
'   please send comments, suggestions, questions to same
'   This code is provided FREE   Please distribute
End Sub

Sub Grid1_KeyDown (keycode As Integer, Shift As Integer)
    If keycode = 13 Then
        keycode = 9
    End If
End Sub

Sub grid1_keypress (keyascii As Integer)
    Dim char As String
    
    'if you want to prevent entry in certain rows or columns then do this
    ' if col or row = ??then
    '  keyascii = 0
    '  exit sub
    ' end if
    Select Case keyascii
        Case 27
            'dont allow escape key
            txtGridBox.Text = grid1.Text
        Case 9, 13
            'move to next cell
            If grid1.Col < (grid1.Cols - 1) Then
                grid1.Col = grid1.Col + 1
            Else
                If grid1.Row < (grid1.Rows - 1) Then
                    grid1.Row = grid1.Row + 1
                    grid1.Col = grid1.FixedCols
                Else
                    grid1.Row = grid1.FixedRows
                    grid1.Col = grid1.FixedCols
                End If
            End If
       'if you want to restrict the possible values in a cell then put code here
       'Case n
       Case Else
            'pass control to text box
            txtGridBox.Text = ""
            char = Chr$(keyascii)
            oldrow = grid1.Row
            oldcol = grid1.Col
            grid1.SelStartRow = grid1.Row
            grid1.SelStartCol = grid1.Col
            txtGridBox.Text = grid1.Text
            txtGridBox.Text = char & txtGridBox.Text
            txtGridBox.SelStart = 1
            ShowTextBox
            keyascii = 0
    End Select

End Sub

Sub Grid1_MouseDown (Button As Integer, Shift As Integer, x As Single, y As Single)
    txtGridBox.Visible = False
    'save current cell text in case of drag and drop
    cliptext = grid1.Text
    mousepointer = 2
End Sub

Sub Grid1_MouseUp (Button As Integer, Shift As Integer, x As Single, y As Single)
    'all of this code is for the drag and drop feature
    Dim i As Integer, thisx As Integer, thisrow As Integer
    Dim thisy As Integer, thiscol As Integer
    thisx = x
    thisy = y
    For i = 0 To grid1.Cols - 1
        If thisx - grid1.ColWidth(i) > 0 Then
            thisx = thisx - grid1.ColWidth(i)
        Else
            thiscol = i
            i = grid1.Cols - 1
        End If
    Next i
    For i = 0 To grid1.Rows - 1
        If thisy - grid1.RowHeight(i) > 0 Then
            thisy = thisy - grid1.RowHeight(i)
        Else
            thisrow = i
            i = grid1.Rows - 1
        End If
    Next i
    'prevent updates in fixed rows
    If thisrow < grid1.FixedRows Or thiscol < grid1.FixedCols Then
        mousepointer = 1
        Exit Sub
    End If
    grid1.Col = thiscol
    grid1.Row = thisrow
    Call GridCellUpdated(cliptext)
    mousepointer = 1
End Sub

Sub GridCellUpdated (newcellvalue As String)
    'place your code here to update your array or tables underlying this grid
    'also code here can determine whether or not to accept value entered
    grid1.Text = newcellvalue$
End Sub

Sub ShowTextBox ()
    Dim x As Integer, y As Integer
    Dim i As Integer

    txtGridBox.Visible = False

    txtGridBox.Height = grid1.RowHeight(grid1.Row) - (screen.TwipsPerPixelY * 2)
    txtGridBox.Width = grid1.ColWidth(grid1.Col) - (screen.TwipsPerPixelX * 2)
    
    x = grid1.Left + (screen.TwipsPerPixelX * 3)
    
    For i = 0 To grid1.Col - 1
        x = x + grid1.ColWidth(i) + screen.TwipsPerPixelX
    Next i

    y = grid1.Top + (screen.TwipsPerPixelY * 2)

    For i = 0 To grid1.Row - 1
        y = y + grid1.RowHeight(i) + screen.TwipsPerPixelY
    Next i

    txtGridBox.Left = x
    txtGridBox.Top = y

    txtGridBox.ZOrder
    txtGridBox.Visible = True
    txtGridBox.SetFocus

End Sub

Sub txtGridBox_KeyDown (keycode As Integer, Shift As Integer)
    Select Case keycode
        Case 38 'arrow up key
            'update previous cell then move to next
            oldrow = grid1.Row
            oldcol = grid1.Col
            If grid1.Row > grid1.FixedRows Then
                grid1.Row = grid1.Row - 1
            Else
                grid1.Row = grid1.Rows - 1
            End If
            grid1.SetFocus
        Case 40 'arrow down key
            'update previous cell then move to next
            oldrow = grid1.Row
            oldcol = grid1.Col
            If grid1.Row < grid1.Rows - 1 Then
                grid1.Row = grid1.Row + 1
            Else
                grid1.Row = grid1.FixedRows
            End If
            grid1.SetFocus
        End Select
End Sub

Sub txtGridBox_keypress (keyascii As Integer)
    'if you want to prevent entry in certain rows or columns then do this
    ' if col or row = ??then
    '  keyascii = 0
    '  exit sub
    ' end if
    Select Case keyascii
        Case 13
            If grid1.Col < grid1.Cols - 1 Then
                grid1.Col = grid1.Col + 1
            Else
                grid1.Col = grid1.FixedCols
                If grid1.Row < grid1.Rows - 1 Then
                    grid1.Row = grid1.Row + 1
                Else
                    grid1.Row = grid1.FixedRows
                End If
            End If
            txtGridBox.Visible = False
            grid1.SetFocus
        Case 27
            'cancel changes to cell
            keyascii = 0
            txtGridBox.Text = grid1.Text
            txtGridBox.Visible = False
            grid1.SetFocus
       'if you want to restrict the possible values in a cell then put code here
       'Case n
    End Select
End Sub

Sub txtGridBox_LostFocus ()
    
    Dim temprow As Integer, tempcol As Integer
    Dim newcellvalue As String

    temprow = grid1.Row
    tempcol = grid1.Col
    grid1.Row = oldrow
    grid1.Col = oldcol
    newcellvalue$ = txtGridBox.Text
    Call GridCellUpdated(newcellvalue$)
    grid1.Row = temprow
    grid1.Col = tempcol
    txtGridBox.Visible = False

End Sub

