VERSION 4.00
Begin VB.Form Reg 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Register..."
   ClientHeight    =   4575
   ClientLeft      =   2295
   ClientTop       =   1845
   ClientWidth     =   4815
   ControlBox      =   0   'False
   Height          =   4980
   Icon            =   "Reg.frx":0000
   Left            =   2235
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4575
   ScaleWidth      =   4815
   ShowInTaskbar   =   0   'False
   Top             =   1500
   Width           =   4935
   Begin VB.CommandButton ComButton 
      Height          =   375
      Index           =   1
      Left            =   3480
      TabIndex        =   8
      Top             =   4080
      Width           =   1215
   End
   Begin VB.CommandButton ComButton 
      Height          =   375
      Index           =   0
      Left            =   120
      TabIndex        =   7
      Top             =   4080
      Width           =   1215
   End
   Begin VB.Frame Frame2 
      Height          =   615
      Left            =   120
      TabIndex        =   4
      Top             =   3360
      Width           =   4575
      Begin VB.TextBox RegText 
         Height          =   285
         Left            =   1800
         TabIndex        =   6
         Top             =   210
         Width           =   2655
      End
      Begin VB.Label Label4 
         Alignment       =   1  'Right Justify
         Caption         =   "Registration Number :"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   1575
      End
   End
   Begin VB.Frame Frame1 
      Height          =   3255
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   4575
      Begin VB.Label DaysLeft 
         Alignment       =   2  'Center
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   2760
         Width           =   4335
      End
      Begin VB.Label Label2 
         Caption         =   $"Reg.frx":0442
         Height          =   2055
         Left            =   120
         TabIndex        =   2
         Top             =   600
         Width           =   4335
      End
      Begin VB.Label Label1 
         Alignment       =   2  'Center
         Caption         =   "Program Name"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   13.5
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   375
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   4335
      End
   End
End
Attribute VB_Name = "Reg"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)

'I store the Registration Number in a string for 3
'reasons.
'1. The Registration Number can be very long and I
'   do not want to have to worry about Data type.
'2. It is easier to use InStr to check Registration
'   Number for key letters or numbers.
'3. I like to put letters andd characters in my
'   Registration Numbers. A Long or Double data type
'   could not store these characters.
Dim RegNumber As String
'This variable holds the FirstUsed date
Dim FirstUsed As Date
'This Variable tells us which ComButton is
'Continue
Dim ContinueControl As Integer

Const AppName = "Sample Reg Number"
Const KeySet = "Settings"
Public Sub GetAppSet()
 'This Sub gets the application settings. Since it
 'is called first you can put all application
 'settings here.
 '
 'This first function gets the Registration
 'Number. If there is not one then "none" is
 'returned.
 RegNumber = GetSetting(AppName, KeySet, "RegNumber", "none")
 'This function gets the date first used. If there
 'is no date located in the System Registry then
 'the function returns the current date.
 FirstUsed = GetSetting(AppName, KeySet, "FirstUsed", Format$(Now, "mm/dd/yy"))
 'If the current date is returned then write that
 'date to the System Registry.
 If FirstUsed = Format$(Now, "mm/dd/yy") And RegNumber = "none" Then
  SaveSetting AppName, KeySet, "FirstUsed", FirstUsed
 End If
End Sub

Sub Ontop(Handle As Long, Pos As Boolean)
Const SWP_NOSIZE = &H1
Const SWP_NOMOVE = &H2
Const SWP_NOACTIVATE = &H10
Const SWP_SHOWWINDOW = &H40
Const HWND_TOPMOST = -1
Const HWND_NOTOPMOST = -2
 wFlags = SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW Or SWP_NOACTIVATE
 Select Case Pos
  Case True
   PosFlag = HWND_TOPMOST
  Case False
   PosFlag = HWND_NOTOPMOST
 End Select
 SetWindowPos Handle, PosFlag, 0, 0, 0, 0, wFlags
End Sub

Public Function RegNumberValid(TestNumber As String) As Boolean
 'This function is where you can insert your routine
 'to validate the registration Number. If there
 'is no number then RegNumber is set to "none" and
 'RegNumberValid = False. If there is a value in
 'RegNumber that is not "none" then check to see
 'if that number is valid.
 RegNumberValid = False
 Select Case TestNumber
  Case "none"
   RegNumberValid = False
  Case Else
   'Inster routine to check for valid registration
   'number. In this case your Registration Number
   'is 0 so I will check to see if the string
   'containded in RegNumber is 0. If so then I return
   'True, else I return False.
   If TestNumber = "0" Then
    RegNumberValid = True
   Else
    RegNumberValid = False
   End If
 End Select
End Function

Public Sub SetDaysLeft()
Static CurrentDate As Date
Static NumDaysLeft As Long
Static NumDaysOnSystem As Long
 CurrentDate = Format(Now, "mm/dd/yy")
 'First, subtract FirstUsed from CurrentDate
 NumDaysOnSystem = CurrentDate - FirstUsed
 'Then Subtract NumDaysOnSystem from 30 to get
 'NumDyasLeft.
 '
 'Note: You can replace 30 with
 'however many days you want to give the user.
 NumDaysLeft = 30 - NumDaysOnSystem
 'Set the caption of DaysLeft appropiatly.
 'Check to make sure NumDaysLeft is < 31 to make
 'sure someone has not been tampering with FirstUsed
 If NumDaysLeft > 10 And NumDaysLeft < 31 Then
  'User has plenty of time and caption is Black
  DaysLeft.ForeColor = &H0
  DaysLeft.Caption = "You have " & Str$(NumDaysLeft) & " days left until you MUST register this software!"
 ElseIf NumDaysLeft < 11 And NumDaysLeft > -1 Then
  'NumDaysLeft is between 0 and 10, the user
  'is running out of time. Set the caption to
  'red (&HFF0000).
  DaysLeft.ForeColor = &HFF0000
  DaysLeft.Caption = "You have " & Str$(NumDaysLeft) & " days left until you MUST register this software!"
 ElseIf NumDaysLeft < 0 Then
  'The user is past the Registration time.
  DaysLeft.ForeColor = &HFF
  DaysLeft.Caption = "You are " & Str$(NumDaysLeft) & " days past registration!"
  'Disable the Continue Control.
  ComButton(ContinueControl).Enabled = False
 ElseIf NumDaysLeft > 30 Then
  'Someone has tampered with the System Registry.
  'Give a message and end.
  MsgBox "There is an error in your System Registry. Please contact the author for more information.", vbCritical, "Reg Sample"
  End
 End If
End Sub

Private Sub ComButton_Click(Index As Integer)
Static Result As Boolean
 'First, check to see if there is something in the
 'RegText box. If there is, check to see if it
 'is a valid number.
 If regtext.Text <> "" Then
  Result = RegNumberValid(regtext.Text)
  Select Case Result
   Case True
    'Tell the user that their number is valid and
    'change the System Registry
    DeleteSetting AppName, KeySet, "FirstUsed"
    SaveSetting AppName, KeySet, "RegNumber", regtext.Text
    MsgBox "Registration Number Accepted.", vbInformation, "Reg Check"
   Case False
    MsgBox "Registration Number Rejected.", vbInformation, "Reg Check"
    regtest.Text = ""
    Exit Sub
  End Select
 End If
 'Find out what button this is and do the appropriate
 'action.
 Select Case ComButton(Index).Caption
  Case "Continue"
   'Load corrent forms. In this case there are
   'none so end.
   Unload Me
   MsgBox "Continue Pressed", vbInformation, "Debug" 'Reomve, for debug purpose only
   End
  Case "Close"
   'End program.
   MsgBox "Close Pressed", vbInformation, "Debug" 'Reomve, for debug purpose only
   End
 End Select
End Sub

Private Sub Form_Load()
Static Result As Boolean
 'Get Progam Settings
 GetAppSet
 'Check to see if Registration Number set by
 'GetAppSet is valid
 Result = RegNumberValid(RegNumber)
 Select Case Result
  Case True
   'Registration Number is valid so load rest of
   'program. In this case, end.
   MsgBox "Correct Reg Number", vbInformation, "Debug" 'For debug purposes only, reomve before you use,
   End
  Case Flase
   'Stored Registration Number is NOT valid.
   'Center Form on screen
   Move (Screen.Width - Reg.Width) / 2, (Screen.Height - Reg.Height) / 2
   'Set Random Button Captions
   ContinueControl = Int((1 - 0 + 1) * Rnd + 0)
   Select Case ContinueControl
    Case 0
     ComButton(0).Caption = "Continue"
     ComButton(1).Caption = "Close"
    Case 1
     ComButton(0).Caption = "Close"
     ComButton(1).Caption = "Continue"
   End Select
   'Set DaysLeft Label to how many days are left
   SetDaysLeft
   'Show this form and float it on top.
   Ontop Me.hwnd, True
 End Select
End Sub


