VERSION 2.00
Begin Form Setup1 
   BackColor       =   &H00400000&
   Caption         =   "Test App Setup"
   ClientHeight    =   2130
   ClientLeft      =   1860
   ClientTop       =   2610
   ClientWidth     =   5640
   ControlBox      =   0   'False
   FillStyle       =   0  'Solid
   FontBold        =   -1  'True
   FontItalic      =   -1  'True
   FontName        =   "MS Sans Serif"
   FontSize        =   24
   FontStrikethru  =   0   'False
   FontUnderline   =   0   'False
   ForeColor       =   &H00000000&
   Height          =   2535
   Left            =   1800
   LinkMode        =   1  'Source
   LinkTopic       =   "Form3"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   142
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   376
   Top             =   2265
   Width           =   5760
   Begin Label Label2 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "To customize this setup program, modify the FORM_LOAD event procedure in this form."
      Height          =   435
      Left            =   15
      TabIndex        =   1
      Top             =   15
      Visible         =   0   'False
      Width           =   5625
   End
   Begin Label Label1 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "This label used for DDE connection to the Program Manager"
      Height          =   390
      Left            =   15
      TabIndex        =   0
      Top             =   525
      Visible         =   0   'False
      Width           =   5610
   End
End

Const fDataAccess% = False
Const fODBC% = False
Const fBtrieve% = False
Const fOLE2% = False

' Set the total uncompressed file sizes
' by adding the sizes of the files
'WinSysNeeded should be approx 10,000 bytes more than
'SetupWizard determines because THIS setup1.exe is larger
'than the setup1.exe created by SetupWizard.  Better to
'overestimate than underestimate, just don't be off by too much.

Const WINSYSNEEDED = 530000' Files that go into WINDOWS and SYSTEM directory

'Use the total file size of the non-registered version since it
'is always larger
Const OTHERNEEDED = 310000' Files that don't go into the WINDOWS or SYSTEM directory

'Numbers determined by SetupWiz
'Const WINSYSNEEDED = 517313' Files that go into WINDOWS and SYSTEM directory
'Const OTHERNEEDED = 307347' Files that don't go into the WINDOWS or SYSTEM directory

Function CreateLicenseFile (DestDir$, SrcDir$)
On Error GoTo LicenseError
    
    Const ATTR_HIDDEN = 2
    Const ATTR_READONLY = 1

    CRLF = Chr$(13) + Chr$(10)
    
    'See if the license file already exists on the source drive
    'If it does, copy the file to the destination and continue with
    'the installation.
    FileName$ = SrcDir$ + "DEMO.LIC"
    If FileExists(FileName$) Then
	FileCopy FileName$, DestDir$ + "DEMO.LIC"
	CreateLicenseFile = True
	Exit Function
    End If
    
    msg$ = "Copyright 1993-1995 Mike Davis" + CRLF
    msg$ = msg$ + "Warning:  This product is licensed to you pursuant to the terms of the" + CRLF
    msg$ = msg$ + "license agreement included with the original software, and is protected" + CRLF
    msg$ = msg$ + "by copyright law and international treaties.  Unauthorized reproduction" + CRLF
    msg$ = msg$ + "or distribution may result in severe civil and criminal penalties," + CRLF
    msg$ = msg$ + "and will be prosecuted to the maximum extent possible under the law." + CRLF

'**********************************************************
'Encrypt the date so the user cannot easily change it in
'the file itself.  Use any encryption method you want.  I
'usually just use something similiar to the following.  If
'you use something different, make certain to also change the
'VerifyLicense function in your program.

    FD = Date$

    For I = 1 To Len(FD)
	Char$ = Mid$(FD, I, 1)
	CodedDate = CodedDate + Chr$(Asc(Char$) + 190)
    Next I
    msg$ = msg$ + CodedDate
'**********************************************************

    'Create the license file on the source disk
    FileNum = FreeFile
    On Error Resume Next
    Do
	Open FileName$ For Output As FileNum
	Select Case Err
	Case 70   'This error occurs if write-protect is enabled
	    Mesg$ = "Setup requires that it have write-access to the distribution disk.  "
	    Mesg$ = Mesg$ + "Please slide the write-protect tab to the enabled position and then "
	    Mesg$ = Mesg$ + "click OK."
	    MsgBox Mesg$, 48, APPNAME + " Setup"
	    Err = 0
	Case Is <> 0
	    GoTo LicenseError
	Case 0
	    Exit Do
	End Select
    Loop
    On Error GoTo LicenseError
    Print #FileNum, msg$
    Close FileNum

    'Now copy the license file to the destination directory
    FileCopy FileName$, DestDir$ + "DEMO.LIC"

    'Set Hidden and ReadOnly attributes for the license file on the source disk
    SetAttr FileName$, ATTR_HIDDEN + ATTR_READONLY
    CreateLicenseFile = True
    Exit Function
LicenseError:
    msg$ = Error$ + "!" + CRLF + CRLF
    msg$ = msg$ + "Aborting Setup!"
    MsgBox msg$, 16, APPNAME + " Setup"
    CreateLicenseFile = False
    Exit Function

End Function

Sub DrawBackground ()
    
    Setup1.CurrentY = 5
    Setup1.CurrentX = 5
    Setup1.ForeColor = QBColor(15)
    Print APPNAME + " Setup"

End Sub

Sub Form_Load ()
'Compile this program as SETUP1.EXE, compress it using COMPRESS -R SETUP1.EXE,
'and then copy it to the master distribution disk.  Run SetupWizard first to get
'values for the disk space requirements.  These are found in the General Declarations
'section of SETUP1A.FRM.  Also copy README.TXT to the master disk.

'***************************************************************************************
'I left in most of the file names for the demo program, since that provides
'a better example of the correct syntax.  Be sure to change file names, etc. as necessary.
'Some comments are simply for my own benefit and might not apply for your program
'Feel free to send comments or questions or if you find other bugs that I didn't,
'to VDG Mike on America Online.  I'm sure I didn't catch all bugs, only those affecting
'my program installation.
'***************************************************************************************

'***************************************************************************************
'Here are some of the changes I made.
    'Added option to install program icon in any PM group or create new group
    'Moved the line 'winDrive$ = UCase$(Left$(WinDir$, 1))' so that it would actually
    '   get the drive letter
    'Added option of reading a doc file from Setup
    'Fixed a bug that occured if the user specified a destination that was 2 directories
    '   deep, for example, c:\winapps\test, AND the first directory (winapps) does not
    '   exist.  This resulted in an error in the IsValidPath function called by
    '   the Command1_Click event of the PathDlg form. Yet, MS included the code
    '   to create both directories.  Go figure.
    'Please note additions to General Declarations of setup1.bas and the 3 additional
    '   procedures:  ParseString, ddepmErrorHandler, and ddepmGetGroups
    'If SETUP1.EXE is executed directly, the default "install from" directory is the
    '   directory that SETUP1.EXE is located in, rather than the A drive.  This is more
    '   convenient for distributing a program that is zipped up and includes this
    '   Setup program.
    'There were a couple other bugs too that I found during testing of this setup,
    '   but unfortunately I didn't document them and can't remember what they were.
'****************************************************************************************
    

    '----------
    ' Initialize
    '----------
    DialogCaption$ = APPNAME + " Setup"
    ShowMainForm DialogCaption$

    WinDir$ = UCase$(GetWindowsDir$())
    winDrive$ = UCase$(Left$(WinDir$, 1))
    WinSysDir$ = UCase$(GetWindowsSysDir$())
    
    '----------------------------------------------------
    ' Get Window version
    '----------------------------------------------------
    TheVerInfo& = GetVersion()
    WinVer& = TheVerInfo& And &HFFFF&
    If Val(Format$(WinVer& Mod 256) + "." + Format$(WinVer& \ 256)) >= 3.1 Then
	gfWin31% = True
    End If
    
    '----------------------------------------------------
    ' OLE 2.0 requires Win 3.1 or greater
    '----------------------------------------------------
    If Not gfWin31% Then    'fOLE2% And Not gfWin31% Then
	MsgBox "Program requires Windows 3.1 or later."
	GoTo ErrorSetup
    End If

    'My app requires Win 3.1 and does not need OLE 2.0, so I
    'modified the above IF statement to reflect this.
    
    '----------------------------------------------------
    ' SETUP.EXE passes the source drive in a command
    ' argument.  If it is empty,  that means the user
    ' executed this .exe directly.  In that case, show
    ' a dialog to get the desired source directory.
    '----------------------------------------------------
    SourcePath$ = Command$
    If SourcePath$ = "" Then
	title$ = DialogCaption$
	caption1$ = "Please enter the drive or path containing the " + APPNAME + " source files."
	caption2$ = "Install From:"
	defaultText$ = App.Path
	defaultDrive$ = Left$(defaultText$, 2)
	Do 'While Err <> 0
	    On Error Resume Next
	    ShowPathDialog title$, caption1$, caption2$, defaultDrive$, defaultText$, SourcePath$, outButton$
    
	    If outButton$ = "exit" Then GoTo ErrorSetup
	    'ChDrive Left$(SourcePath$, 2)': ChDir "\"
	    If Right$(SourcePath$, 2) = ":\" Then
		ChDir "\"
	    Else
		ChDir Left$(SourcePath$, Len(SourcePath$) - 1)
	    End If
	    If Err <> 0 Then
		msg$ = "The source directory you entered does not exist.  Please verify that you typed the correct directory name."
		MsgBox msg$, 48, APPNAME + " Setup"
		defaultDrive$ = Left$(SourcePath$, 2)
		defaultText$ = SourcePath$
	    'End If
	    ElseIf Not FileExists(SourcePath$ + "DEMO.EX_") Then
		msg$ = "Could not find the " + APPNAME + " source files in the specified directory.  Please verify that you typed the correct directory name."
		MsgBox msg$, 48, APPNAME + " Setup"
		defaultDrive$ = Left$(SourcePath$, 2)
		defaultText$ = SourcePath$
	    End If
	    Setup1.ScaleMode = 3
	    ShowMainForm DialogCaption$
	Loop While Err <> 0
	On Error GoTo 0
    Else
	If Right$(SourcePath$, 1) <> "\" Then
	    SourcePath$ = SourcePath$ + "\"
	End If
    End If


    '--------------------
    ' Get Destination Path
    '--------------------
    title$ = DialogCaption$
    caption1$ = "If you want to install " + APPNAME + " in a different directory and/or drive, type the name of the directory."
    caption2$ = "Install To:"
    defaultDrive$ = "C:"
    defaultText$ = APPDIR

    ShowPathDialog title$, caption1$, caption2$, defaultDrive$, defaultText$, DestPath$, outButton$

    If outButton$ = "exit" Then GoTo ErrorSetup
    
    '---------------------
    ' Sample Option Dialog
    '---------------------
'    ReDim Caption(1 To 4) As String
'    ReDim choice(1 To 4) As Integer
'
'    title$ = dialogCaption$
'    numOptions = 4
'    Caption(1) = "Sample Option 1"
'    Caption(2) = "Sample Option 2"
'    Caption(3) = "Sample Option 3"
'    Caption(4) = "Sample Option 4"
'    helpTxt$ = "Choose your options!   These options are not actually used by this setup program, but by looking in the SETUP1.FRM code you can see how to implement your own option dialogs."

'    ShowOptionDialog title$, numOptions, Caption$(), helpTxt$, choice(), outButton$

'    If outButton$ = "exit" Then
'        GoTo ErrorSetup
'    Else
'        If choice(1) Then MsgBox "Option #1 Selected", 48, "SETUP"
'        If choice(2) Then MsgBox "Option #2 Selected", 48, "SETUP"
'        If choice(3) Then MsgBox "Option #3 Selected", 48, "SETUP"
'        If choice(4) Then MsgBox "Option #4 Selected", 48, "SETUP"
'    End If


    '-----------------------------------------
    ' Dim disk space variables as Long Integers
    '-----------------------------------------
    Dim winSpaceFree As Long
    Dim sourceSpaceFree As Long
    Dim destSpaceFree As Long
    Dim totalNeeded As Long

    '---------------------------------------------------------
    ' If the Windows \SYSTEM directory is a subdirectory
    ' of the Windows directory, the proper place for
    ' installation of .VBXs and shared .DLLs is the
    ' Windows \SYSTEM directory.
    '
    ' If the Windows \SYSTEM directory is *not* a subdirectory
    ' of the Windows directory, then the user is running a
    ' shared version of Windows, and the proper place for
    ' installation of .VBXs and shared .DLLs is the
    ' Windows directory.
    '---------------------------------------------------------
    If InStr(WinSysDir$, WinDir$) = 0 Then
	WinSysDir$ = WinDir$
    End If

    
    '---------------------------------
    ' Get Drive Letters of directories
    '---------------------------------
    destDrive$ = UCase$(Left$(DestPath$, 1))
    sourceDrive$ = UCase$(Left$(SourcePath$, 1))

    '---------------------------------
    ' Compute free disk space variables
    '---------------------------------
    winSpaceFree = GetDiskSpaceFree(winDrive$)
    destSpaceFree = GetDiskSpaceFree(destDrive$)
    
    '-----------------------------------------
    ' Check for enough disk space.
    '
    ' Some components are being installed into the
    ' Windows\SYSTEM directory.
    '
    ' So if the main destination path is on a
    ' different drive than the drive with
    ' the Windows \SYSTEM directory, we have to
    ' check both drives.
    '
    ' An example of this is when the user is installing
    ' the main product to drive D:, but the Windows
    ' directory is on drive c:
    ' -----------------------------------------
    totalNeeded = WINSYSNEEDED + OTHERNEEDED
    
    If winDrive$ = destDrive$ Then
	If destSpaceFree < totalNeeded Then
	    MsgBox "There is not enough disk space on drive " + destDrive$ + ":   An estimated" + Str$(totalNeeded - destSpaceFree) + " additional bytes are needed.", 16, DialogCaption$
	    GoTo ErrorSetup
	End If
    Else
	If winSpaceFree < WINSYSNEEDED Then
	    MsgBox "There is not enough disk space on drive " + winDrive$ + ":  An estimated" + Str$(WINSYSNEEDED - winSpaceFree) + " additional bytes are needed.", 16, DialogCaption$
	    GoTo ErrorSetup
	End If
	If destSpaceFree < OTHERNEEDED Then
	    MsgBox "There is not enough disk space on drive " + destDrive$ + ":  An estimated" + Str$(OTHERNEEDED - destSpaceFree) + " additional bytes are needed.", 16, DialogCaption$
	    GoTo ErrorSetup
	End If
	
    End If



    '----------------------------
    ' Create destination directory
    '----------------------------
    If Not CreatePath(DestPath$) Then GoTo ErrorSetup
    
    '----------------------------
    ' Create the license file in the destination directory
    '----------------------------
    If CreateLicenseFile(DestPath$, SourcePath$) = False Then
	GoTo ErrorSetup
    End If

    '-----------------------------------------------------------
    ' Show Status Dialog -- This stays up while copying files
    ' It is required by the CopyFile routine
    '-----------------------------------------------------------
    ShowStatusDialog DialogCaption$, totalNeeded
    
    
    '-----------
    ' Copy Files
    '-----------

    ' Test to see if loan.exe is on the disk, if not then you know the user
    ' did not insert the first disk
If Not PromptForNextDisk(1, SourcePath$ + "DEMO.EX_") Then GoTo ErrorSetup
If Not CopyFile(SourcePath$, DestPath$, "DEMO.EX_", "DEMO.EXE") Then GoTo ErrorSetup
If Not CopyFile(SourcePath$, DestPath$, "DEMO.WR_", "DEMO.WRI") Then GoTo ErrorSetup
'If Not CopyFile(SourcePath$, DestPath$, "FEES.WR_", "FEES.WRI") Then GoTo ErrorSetup
'If Not CopyFile(SourcePath$, DestPath$, "LICENSE.WR_", "LICENSE.WRI") Then GoTo ErrorSetup
'If Not CopyFile(SourcePath$, DestPath$, "CHANGES.TX_", "CHANGES.TXT") Then GoTo ErrorSetup
If Not CopyFile(SourcePath$, DestPath$, "DEMO.TX_", "DEMO.TXT") Then GoTo ErrorSetup
'If Not CopyFile(SourcePath$, DestPath$, "README.TXT", "README.TXT") Then GoTo ErrorSetup

    ' Install loan.exe and grid.vbx in the destPath$


    ' If you have more than one distribution disk, call PromptForNextDisk after
    ' you have installed all the files from the previous disk. This line tests to
    ' see if foo.da_ is on disk 2. If not, you know the user has not inserted disk 2.
    ' The call to PromptForNextDisk is commented out, since loan.exe can be installed
    ' from a single distribution disk.
    
    ' If Not PromptForNextDisk(2, SourcePath$ + "foo.da_") Then GoTo ErrorSetup
    ' If Not CopyFile(SourcePath$, destPath$, "foo.da_", "foo.dat", 0) Then GoTo ErrorSetup


    '--------------------------------------------------
    ' File Copying is over, so unload the status dialog
    '--------------------------------------------------
    Unload StatusDlg


    '-----------------------------------------------------------
    ' Show static message while working on DDE to Program Manager
    '-----------------------------------------------------------
    'ShowStaticMessageDialog dialogCaption$, "Creating Program Manager Icon..."


    '--------------------------------------
    ' Create program manager group and icon
    '--------------------------------------
'CreateProgManGroup Setup1, APPNAME, "DEMO.GRP"

PMGroupList.Show 1

CreateProgManItem Setup1, DestPath$ + "DEMO.EXE", "Demo Program"
CreateProgManItem Setup1, DestPath$ + "DEMO.TXT", "About the Demo"
CreateProgManItem Setup1, DestPath$ + "DEMO.WRI", "User Manual"

'These are just other files that I distribute
'CreateProgManItem Setup1, DestPath$ + "LICENSE.WRI", "License Agreement"
'CreateProgManItem Setup1, DestPath$ + "FEES.WRI", "Site License Fees"
'CreateProgManItem Setup1, DestPath$ + "CHANGES.TXT", "New To This Version"


    '-------------------------------------------------
    ' Since SETUP.EXE copies your setup program to the Windows
    ' directory, it is possible for your user to
    ' execute this program directly.
    '
    ' As a usability feature, you may wish to insert code
    ' here to install a program manager icon that executes
    ' your setup program in the windows drive.  This
    ' allows th user to re-run setup at a later time to
    ' install options that were not installed the first
    ' time.
    '-------------------------------------------------

    'Personally, I think it would be better to copy your setup program to your
    'application's directory, if you want to do what MS states above.  This makes it
    'obvious for the user to determine what application the setup program is for.
    'Also, what happens if the user installs another VB program?  Your
    'setup program will be overwritten, that's what. This could REALLY confuse
    'novice users who double click your setup program icon and a different setup
    'program starts instead.   Since I add Version Information to both the SETUP1.EXE
    'and my program's .EXE, I have my programs determine if any SETUP1.EXE that exists
    'in the Windows directory is the setup for my program, and if so, delete it.

    '-------------------
    ' Hide Static Message
    '-------------------
    MessageDlg.Hide
    

    '--------------------------------------------------------------
    ' If OLE2.DLL already exists, then ignore the OLE 2 flag.
    ' Otherwise, if we are installing an application that uses
    ' OLE 2.0, we need to register the OLE 2 DLL's via REGEDIT.EXE.
    '
    ' Do not copy OLE dlls unless you check the versions and assure
    ' that the versions you plan to install postdate the ones on
    ' the users machine.
    '
    '
    ' The data access engine and OLE 2.0 need to have SHARE.EXE
    ' loaded. Check AUTOEXEC.BAT and add if needed.  NOTE: If
    ' running Window For WorkGroup, then do not add SHARE.  WFW
    ' use its own sharing mechanism, VSHARE.386.
    '----------------------------------------------------------
    If fDataAccess% Or fOLE2% And Not FileExists(WinSysDir$ + "\" + "OLE2.DLL") Then
	ret$ = Space$(255)
	x% = GetPrivateProfileString("BOOT", "NETWORK.DRV", "", ret$, Len(ret$), "SYSTEM.INI")
	If x% Then ret$ = Left(ret$, x%)
	If InStr(1, UCase$(ret$), "WFWNET.DRV") = 0 Then
	    AddShareIfNeeded WinSysDir$, "SHARE.EXE"
	End If
    End If

    '----------------------------
    ' Need to register OLE 2.0 dlls
    '----------------------------
    If fOLE2% And Not FileExists(WinSysDir$ + "\" + "OLE2.DLL") Then
	x% = Shell("regedit /s ole2.reg")
    End If

    '-------------------------------------------------------
    ' Do not change this if statement.  Used by Setup Wizard
    '-------------------------------------------------------
    If fODBC% Then
	CreateProgManItem Setup1, DestPath$ + "DEMO.EXE", APPNAME
	MsgBox "Before you can run a Visual Basic ODBC application using the SQL Server driver, you must first update the ODBC catalog of stored procedures.  These procedures are provided in the INSTCAT.SQL file.  Typically, the system administrator for SQL Server should install these procedures, using the SQL Server ISQL utility."
    End If

    '-------------------------------------------------------
    ' Do not change this if statement.  Used by Setup Wizard
    '-------------------------------------------------------
    If fBtrieve% Then
	' See notes in Appendix C
	retstr$ = String$(255, 32)
	x% = GetPrivateProfileString%("BTRIEVE", "OPTIONS", "1", retstr$, Len(retstr$), "WIN.INI")
	If x% <= 1 Then
	    x% = WritePrivateProfileString%("BTRIEVE", "OPTIONS", "/m:64 /p:4096 /b:16 /f:20 /l:40 /n:12 /t:" + DestPath$ + "BTRIEVE.TRN", "WIN.INI")
	End If
    End If

    '--------------------------
    ' Display the demo.txt file
    '--------------------------
    ReadMe.Show 1
    
    '------------------
    ' Show Final message
    '------------------
    MsgBox APPNAME + " Installation is Complete!", 48, DialogCaption$
    
    On Error Resume Next
    
    'Ask if the user wants to read the documentation now
    Response% = MsgBox("Do you wish to read the documentation file now?", 36, DialogCaption$)
    If Response% = 6 Then
	FiletoOpen$ = "write.exe " + DestPath$ + "demo.wri"
	Success% = Shell(FiletoOpen$, 3)
	If Success% = 0 Then
	    MsgBox "Could not start Windows Write", 48, DialogCaption$
	End If
	While GetModuleUsage(Success%) > 0      ' Has Shelled program finished?
	    z% = DoEvents()                     ' If not, yield to Windows.
	Wend
    End If


ExitSetup:
    Setup1.Hide
    RestoreProgMan         'Show the program manager
    Unload Me
    Exit Sub

ErrorSetup:
    MsgBox APPNAME + " is not properly installed.  Please re-run setup at a later time to install " + APPNAME + " properly.", 48, DialogCaption$
    ChDrive winDrive$   ' Set back to hard disk
    ChDir Left$(WinDir$, Len(WinDir$) - 1)
    Unload Me
    Exit Sub
    
End Sub

Sub Form_Paint ()
    DrawBackground
End Sub

Sub Form_Unload (Cancel As Integer)
    End
End Sub

'---------------------------------------------------------------
' Sets the form's caption, Paints 3-D Background Text, Shows Form
'---------------------------------------------------------------
Sub ShowMainForm (Caption$)
    Screen.MousePointer = 11
    Setup1.Caption = Caption$
    Setup1.Move 0, 0, Screen.Width, Screen.Height * .85
    
    Setup1.Show
    Setup1.Refresh
    
    Setup1.ScaleMode = 2
    Setup1.FontSize = 24
    Setup1.FontBold = True
    Setup1.FontItalic = True
    
    DrawBackground
    
End Sub

Sub ShowPathDialog (title$, caption1$, caption2$, defaultDrive$, defaultText$, SourcePath$, outButton$)
	Screen.MousePointer = 11
	Load PathDlg
	PathDlg.Caption = title$
	PathDlg.Label1.Caption = caption1$
	PathDlg.Label2.Caption = caption2$
	PathDlg.inDrive.Tag = defaultDrive$
	PathDlg.Text1.Text = defaultText$
	PathDlg.Text1.SelStart = 0
	PathDlg.Text1.SelLength = Len(defaultText$)
	CenterForm PathDlg
	Screen.MousePointer = 0

	PathDlg.Show 1
	
	SourcePath$ = PathDlg.outPath.Tag
	outButton$ = PathDlg.outButton.Tag
	Unload PathDlg
End Sub

Sub ShowStaticMessageDialog (title$, Caption$)

    Load MessageDlg
    CenterForm MessageDlg
    MessageDlg.Caption = title$
    MessageDlg.Label.Caption = Caption$
    MessageDlg.Show
    MessageDlg.Refresh

End Sub

Sub ShowStatusDialog (title$, totalBytes As Long)

    Load StatusDlg
    StatusDlg.Caption = title$
    StatusDlg.total.Tag = Str$(totalBytes)
    CenterForm StatusDlg
    StatusDlg.Show

End Sub

