VERSION 2.00
Begin Form cover 
   BackColor       =   &H00FF0000&
   Caption         =   "    Animated command button"
   ClientHeight    =   1815
   ClientLeft      =   3135
   ClientTop       =   2550
   ClientWidth     =   2895
   ControlBox      =   0   'False
   Height          =   2220
   Icon            =   SPRITE3.FRX:0000
   Left            =   3075
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   MousePointer    =   1  'Arrow
   ScaleHeight     =   1815
   ScaleWidth      =   2895
   Top             =   2205
   Width           =   3015
   Begin PictureBox Picture1 
      Height          =   1095
      Left            =   360
      ScaleHeight     =   1065
      ScaleWidth      =   2145
      TabIndex        =   3
      Top             =   360
      Width           =   2175
      Begin PictureBox AnimationPicture 
         Height          =   2535
         Left            =   0
         Picture         =   SPRITE3.FRX:0302
         ScaleHeight     =   167
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   143
         TabIndex        =   4
         Top             =   -960
         Width           =   2175
      End
   End
   Begin PictureBox OffscreenCompositePicture 
      AutoSize        =   -1  'True
      Height          =   3255
      Left            =   7680
      ScaleHeight     =   215
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   247
      TabIndex        =   1
      Top             =   2880
      Width           =   3735
   End
   Begin PictureBox BufferPicture 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   3240
      Left            =   7560
      ScaleHeight     =   214
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   247
      TabIndex        =   0
      Top             =   2880
      Width           =   3735
   End
   Begin CheckBox HideBufferCheck 
      Caption         =   "Hide Buffers"
      Height          =   252
      Left            =   6840
      TabIndex        =   2
      Top             =   4440
      Visible         =   0   'False
      Width           =   1524
   End
   Begin Timer Timer1 
      Interval        =   300
      Left            =   6600
      Top             =   0
   End
End



Option Explicit
Declare Function mcisendstring& Lib "mmsystem.dll" (ByVal lpstcommand$, ByVal lpstrreturnstring$, ByVal ureturnlength%, ByVal hwndcallback%)
Const sndsync = &H0
Const snd_async = &H1
Const snd_nodefault = &H2


Dim Forward As Integer
Dim Down As Integer
Dim CurrentLeft As Integer
Dim CurrentTop As Integer
Dim OldLeft As Integer
Dim OldTop As Integer
Dim CurrentSpriteCel As Integer

Dim bmBitmapFileHeader As BITMAPFILEHEADER
Dim bmBitmapInfo As BITMAPINFO
Dim hSpritePal As Integer
Dim hBitmapPixelData As Integer
Dim hMaskPixelData As Integer
Dim hSpritePixelData As Integer

Dim SpriteBitmapFiles() As String
Dim SpriteDIBHandles() As Integer
Dim NumberOfSprites As Integer

Sub AnimationPicture_Click ()
End
End Sub

Sub AnimationPicture_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
PaintFrames CTLRECESSED
End Sub

Sub AnimationPicture_MouseUp (Button As Integer, Shift As Integer, X As Single, Y As Single)
PaintFrames CTLRAISED
End Sub

Sub AnimationPicture_Paint ()
    Dim dummy As Integer
    Dim SpriteWidth As Integer
    Dim SpriteHeight As Integer
    Dim CurrentX As Integer
    Dim OffscreenCompositeWidth As Integer
    Dim OffscreenCompositeHeight As Integer
    Dim lpMaskPixelData As Long
    Dim lpSpritePixelData As Long

    If Forward Then
	SpriteWidth = bmBitmapInfo.bmiHeader.biWidth
	CurrentX = CurrentLeft
      Else
	SpriteWidth = -bmBitmapInfo.bmiHeader.biWidth
	CurrentX = CurrentLeft + bmBitmapInfo.bmiHeader.biWidth - 1
      End If
    SpriteHeight = bmBitmapInfo.bmiHeader.biHeight
    OffscreenCompositeWidth = Abs(SpriteWidth) + Abs(CurrentLeft - OldLeft)
    OffscreenCompositeHeight = SpriteHeight + Abs(CurrentTop - OldTop)
    ' Copy bounding rectangle of old and new positions to offscreen composite buffer.
    dummy = BitBlt(OffscreenCompositePicture.hDC, 0, 0, OffscreenCompositeWidth, OffscreenCompositeHeight, animationpicture.hDC, MinInt(OldLeft, CurrentLeft), MinInt(OldTop, CurrentTop), SRCCOPY)
    ' Restore previously covered area by copying hold buffer to composite buffer.
    dummy = BitBlt(OffscreenCompositePicture.hDC, MaxInt(0, OldLeft - CurrentLeft), MaxInt(0, OldTop - CurrentTop), Abs(SpriteWidth), SpriteHeight, BufferPicture.hDC, 0, 0, SRCCOPY)
    ' Copy area that will become next position from composite buffer to hold buffer.
    dummy = BitBlt(BufferPicture.hDC, 0, 0, Abs(SpriteWidth), SpriteHeight, OffscreenCompositePicture.hDC, MaxInt(0, CurrentLeft - OldLeft), MaxInt(0, CurrentTop - OldTop), SRCCOPY)
    ' Copy Mask and Sprite to composite buffer.
    lpMaskPixelData = GlobalLock(SpriteDIBHandles(CurrentSpriteCel, 1))
    lpSpritePixelData = GlobalLock(SpriteDIBHandles(CurrentSpriteCel, 2))
    dummy = StretchDIBits(OffscreenCompositePicture.hDC, MaxInt(CurrentX - CurrentLeft, CurrentX - OldLeft), MaxInt(0, CurrentTop - OldTop), SpriteWidth, SpriteHeight, 0, 0, Abs(SpriteWidth), SpriteHeight, lpMaskPixelData, bmBitmapInfo, DIB_RGB_COLORS, SRCAND)
    dummy = StretchDIBits(OffscreenCompositePicture.hDC, MaxInt(CurrentX - CurrentLeft, CurrentX - OldLeft), MaxInt(0, CurrentTop - OldTop), SpriteWidth, SpriteHeight, 0, 0, Abs(SpriteWidth), SpriteHeight, lpSpritePixelData, bmBitmapInfo, DIB_RGB_COLORS, SRCPAINT)
    ' Copy composite buffer to screen DC.
    dummy = BitBlt(animationpicture.hDC, MinInt(OldLeft, CurrentLeft), MinInt(OldTop, CurrentTop), OffscreenCompositeWidth, OffscreenCompositeHeight, OffscreenCompositePicture.hDC, 0, 0, SRCCOPY)
    lpMaskPixelData = GlobalUnlock(SpriteDIBHandles(CurrentSpriteCel, 1))
    lpSpritePixelData = GlobalUnlock(SpriteDIBHandles(CurrentSpriteCel, 2))

    OldLeft = CurrentLeft
    OldTop = CurrentTop
    BufferPicture.Refresh
    'OffscreenCompositePicture.Refresh
    End Sub

Sub Form_Activate ()
    Dim dummy As Integer
    dummy = BitBlt(BufferPicture.hDC, 0, 0, bmBitmapInfo.bmiHeader.biWidth, bmBitmapInfo.bmiHeader.biHeight, animationpicture.hDC, CurrentLeft, CurrentTop, SRCCOPY)

    End Sub

Sub Form_Load ()
PaintFrames CTLRAISED
   playmusic (True)
   Dim sflag%, dummy%
   sflag% = snd_async Or snd_nodefault
	
       
	
	
	BufferPicture.AutoRedraw = True
	BufferPicture.Visible = False
	OffscreenCompositePicture.AutoRedraw = True
	OffscreenCompositePicture.Visible = False
    
    
    timer1.Enabled = False
    Forward = True
    Down = True
    CurrentLeft = -5
    CurrentTop = 100
    ReDim SpriteBitmapFiles(1)
    ReDim SpriteDIBHandles(6, 2)
    SpriteBitmapFiles(1) = App.Path & "\skull.bmp"
    'SpriteBitmapFiles(2) = App.Path & "\sa2.bmp"
    'SpriteBitmapFiles(3) = App.Path & "\Moth3.DIB"
    'SpriteBitmapFiles(4) = App.Path & "\Moth4.DIB"
    'SpriteBitmapFiles(5) = App.Path & "\Moth3.DIB"
    'SpriteBitmapFiles(6) = App.Path & "\Moth2.DIB"
    Screen.MousePointer = 11 ' Hourglass
    NumberOfSprites = LoadAndPrepareSprites(1)
    Screen.MousePointer = 0
    timer1.Enabled = True
    FrameWidth = DEFAULTWIDTH
   
    Show
   

   End Sub

Sub Form_Paint ()
  PaintFrames CTLRAISED
End Sub

Sub Form_QueryUnload (Cancel As Integer, UnloadMode As Integer)
Unload Me
End Sub

Sub Form_Unload (Cancel As Integer)
    Dim SpriteCounter As Integer
    Dim Counter As Integer

    For SpriteCounter = 1 To NumberOfSprites
	For Counter = 1 To 2
	    If SpriteDIBHandles(SpriteCounter, Counter) <> 0 Then
		SpriteDIBHandles(SpriteCounter, Counter) = GlobalFree(SpriteDIBHandles(SpriteCounter, Counter))
	      End If
	    Next Counter
	Next SpriteCounter

    If hBitmapPixelData <> 0 Then
	hBitmapPixelData = GlobalFree(hBitmapPixelData)
      End If
    End Sub

Sub HideBufferCheck_Click ()
'    If HideBufferCheck = 1 Then
 '       BufferPicture.AutoRedraw = True
  '      BufferPicture.Visible = False
   '     OffscreenCompositePicture.AutoRedraw = True
    '    OffscreenCompositePicture.Visible = False
    '  Else
     '   BufferPicture.Visible = True
     '   BufferPicture.AutoRedraw = True
     '   OffscreenCompositePicture.Visible = True
      '  OffscreenCompositePicture.AutoRedraw = False
      'End If
    End Sub

Sub InitCtl (C As Control, InOut As Integer)
    If TypeOf C Is HScrollBar Then      ' No BackColor for Scroll Bars
    Else
	C.BackColor = C.Parent.BackColor        ' Set to Forms Backcolor
    End If
    HighLight C, InOut
End Sub

'
Function LoadAndPrepareSprites (SpritesToLoad As Integer) As Integer
    Dim SpriteCounter As Integer
    Dim MsgString As String
    Dim RetValue As Integer

    SpriteCounter = 1
    Do While SpriteCounter <= SpritesToLoad
	ReadBitmapFile SpriteBitmapFiles(SpriteCounter), bmBitmapFileHeader, bmBitmapInfo, hBitmapPixelData
	If bmBitmapInfo.bmiHeader.biBitCount <> 8 Then
	    MsgString = "File " & SpriteBitmapFiles(SpriteCounter) & " has " & Str$(bmBitmapInfo.bmiHeader.biBitCount) & " bit pixels." & Chr$(13) & Chr$(10)
	    MsgString = MsgString & "Please load only 8-bit images."
	    MsgBox MsgString, 16, "Load Error"
	    LoadAndPrepareSprites = False
	  Else
	    SpriteDIBHandles(SpriteCounter, 1) = ConvertImageToMask(bmBitmapInfo, hBitmapPixelData)
	    SpriteDIBHandles(SpriteCounter, 2) = ConvertImageToSprite(bmBitmapInfo, hBitmapPixelData)
	    SpriteCounter = SpriteCounter + 1
	  End If
	hBitmapPixelData = GlobalFree(hBitmapPixelData)
	DoEvents
	Loop
    LoadAndPrepareSprites = SpriteCounter - 1
    End Function

Sub PaintFrames (InOut As Integer)
' Convert All forms to Single View.
    Cls  ' Remove Old Frames
   
    
    InitCtl picture1, InOut
    InitCtl picture1, InOut
' Other elements that need initialization.
    animationpicture.Refresh ' Repaint Picture Box
picture1.Refresh
End Sub

Sub Picture1_Click ()


Dim rc&
rc& = mcisendstring&("close sq", "", 0, 0)

  End
End Sub

Sub Picture1_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
PaintFrames CTLRECESSED
End Sub

Sub Picture1_MouseUp (Button As Integer, Shift As Integer, X As Single, Y As Single)
PaintFrames CTLRAISED
End Sub

Sub Picture2_MouseUp (Button As Integer, Shift As Integer, X As Single, Y As Single)
 PaintFrames CTLRAISED
End Sub

 Sub playmusic (playflag%)

Dim rc&
If (playflag%) = True Then
rc& = mcisendstring&("close sq", " ", 0, 0)
rc& = mcisendstring&("open SLEIGHRD.mid type sequencer alias sq ", "", 0, 0)
'rc& = mcisendstring&("open white_xm.mid type sequencer alias sq ", "", 0, 0)
If (rc = 0) Then
rc& = mcisendstring&("play sq from 0", "", 0, 0)
End If
Else
rc& = mcisendstring&("close sq", "", 0, 0)
End If
End Sub

Sub Timer1_Timer ()
    Dim Limit As Single
    Dim SpriteWidth As Single

    SpriteWidth = bmBitmapInfo.bmiHeader.biWidth
    CurrentSpriteCel = CurrentSpriteCel Mod NumberOfSprites + 1
    If (((CurrentLeft + SpriteWidth) >= animationpicture.ScaleWidth) And Forward) Then
	Forward = False
'This controls the sprites motion to the left of the screen
      ElseIf ((CurrentLeft <= 0) And Not Forward) Then
	Forward = True
      End If
    If Forward Then
	Limit = animationpicture.ScaleWidth - SpriteWidth
	CurrentLeft = MinSingle(CurrentLeft + 10, Limit)
      Else
	Limit = bmBitmapInfo.bmiHeader.biWidth
	CurrentLeft = MaxSingle(CurrentLeft - 10, 0)
      End If
   ' If (((CurrentTop + bmBitmapInfo.bmiHeader.biHeight) >= AnimationPicture.ScaleHeight) And Down) Or ((CurrentTop <= 200) And Not Down) Then
    '  '  Down = Not Down
     ' End If
    'If Down Then
      '  Limit = AnimationPicture.ScaleHeight - bmBitmapInfo.bmiHeader.biHeight
       ' CurrentTop = MinSingle(CurrentTop + 7, Limit)
     ' Else
      '  CurrentTop = MaxSingle(CurrentTop - 7, 0)
     ' End If
    
    'AnimationPicture.Refresh
    AnimationPicture_Paint
    End Sub

