VERSION 2.00
Begin Form noth 
   BackColor       =   &H00000000&
   Caption         =   "Use left and right mouse buttons to change speed, hit a key to end."
   ClientHeight    =   5820
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7365
   ControlBox      =   0   'False
   Height          =   6225
   Left            =   1035
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5820
   ScaleWidth      =   7365
   Top             =   1140
   Width           =   7485
   WindowState     =   2  'Maximized
End

Sub Form_KeyPress (KeyAscii As Integer)
    End
End Sub

Sub Form_MouseDown (button As Integer, Shift As Integer, x As Single, y As Single)

If button = 1 Then
    init
    If inc > .7 Then inc = inc - .02    'don't let 'em go TOO fast
    If inc = 0 Then inc = -.02          'make sure they don't sit still
    ft = 0
End If

If button = 2 Then
    init
    If inc < 1.3 Then inc = inc + .02   'like above
    If inc = 0 Then inc = .02           '    "
    ft = 0
End If

End Sub

Sub Form_Paint ()
    
    init
    shuffle
    
    inc = .95
    
    h = Int(noth.ScaleWidth / 2)
    v = Int(noth.ScaleHeight / 2)
    c = Int(16777215)
    Randomize
    
    k2 = TwoPi / pnts

Do
    'see if stars are either off the screen...
    For xx = 0 To pnts - 1
        If inc > 1 Then
            If ii(xx).r > noth.ScaleWidth / 1.1 Then ii(xx).r = ((ii(xx).num + 1) * 30) / 2
            If ii(xx).rt > noth.ScaleWidth / 1.1 Then ii(xx).rt = ((ii(xx).num + 1) * 30) / 2
        ElseIf inc < 1 Then   '...or too close to center...
            If ii(xx).r < ((ii(xx).num + 1) * 30) / 2 Then ii(xx).r = noth.ScaleWidth / 1.1
            If ii(xx).rt < ((ii(xx).num + 1) * 30) / 2 Then ii(xx).rt = noth.ScaleWidth / 1.1
            '...and reset positions, at diversified points based on star number
        End If
    Next xx
    gonow   'draw stars and shadows in current positions
    DoEvents
Loop

End Sub

Sub Form_Unload (Cancel As Integer)
    End
End Sub

Sub gonow ()
    
'First, compute shadow position
'Changing the "If ft > -1" adjusts delay;
'i.e. a larger number yields a longer star
'"trail"  (just try it and you'll see...)

If ft > 0 Then
    For p = 0 To pnts - 1
        k3 = k2 * ii(p).num
        ii(p).xs = (ii(p).rt * Cos(k3) * ratio) + h
        ii(p).ys = -(ii(p).rt * Sin(k3)) + v
    Next p

'now cover the old star with a black star

    For xx = 0 To pnts - 1
        PSet (ii(xx).xs, ii(xx).ys), 0&
        ii(xx).rt = ii(xx).rt * inc
    Next xx
End If
    
'compute star position as above

    For p = 0 To pnts - 1
        k3 = k2 * ii(p).num
        ii(p).x = (ii(p).r * Cos(k3) * ratio) + h
        ii(p).y = -(ii(p).r * Sin(k3)) + v
    Next p

    For xx = 0 To pnts - 1
        PSet (ii(xx).x, ii(xx).y), c
        ii(xx).r = ii(xx).r * inc
    Next xx
    
'limit ft increment to avoid overflows (delay counter--see above)
    If ft < 100 Then ft = ft + 1

End Sub

'sets some intitial values
'
Sub init ()
    
    Randomize

    noth.Cls

'change to increase or decrease number of stars
    pnts = 50
    
'here's where the computations begin
'each star is actually one point on an ellipse.
'so here, i assign an initial radius for each
'star and corresponding shadow.
    For p = 0 To pnts - 1
        ii(p).r = (Rnd * (noth.ScaleWidth / 4)) + 100
        ii(p).rt = ii(p).r
    Next p
    
'also used in computations.
'is aspect ratio for elipses mentioned above.
    ratio = noth.Width / noth.Height

'does what it sounds like (see sub for more info).
    shuffle

End Sub

Sub shuffle ()
    
'set values for star numbers
    For x = 1 To pnts
        ii(x).num = x
    Next x

'randomly rearrange star numbers
    For foo = 1 To 3
    For x = 0 To pnts - 1
       hldr = ii(x).num
        newn = Int(Rnd * pnts)
        ii(x).num = newn
        ii(newn).num = hldr
    Next x
    Next foo
    
End Sub

