VERSION 4.00
Begin VB.Form Form1 
   Appearance      =   0  'Flat
   BackColor       =   &H00FF0000&
   Caption         =   "Shoot the Dice"
   ClientHeight    =   4905
   ClientLeft      =   855
   ClientTop       =   1515
   ClientWidth     =   7965
   Height          =   5310
   Left            =   795
   LinkTopic       =   "Form1"
   ScaleHeight     =   4905
   ScaleWidth      =   7965
   Top             =   1170
   Width           =   8085
   Begin VB.PictureBox Picture3 
      Appearance      =   0  'Flat
      BackColor       =   &H00FF0000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   375
      Left            =   720
      ScaleHeight     =   375
      ScaleWidth      =   375
      TabIndex        =   3
      Top             =   2520
      Width           =   375
   End
   Begin VB.PictureBox Picture2 
      Appearance      =   0  'Flat
      BackColor       =   &H00FF0000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   240
      ScaleHeight     =   615
      ScaleWidth      =   495
      TabIndex        =   2
      Top             =   1320
      Width           =   495
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Shoot"
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      Top             =   4200
      Width           =   1455
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      BackColor       =   &H00FF0000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   495
      Left            =   240
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   0
      Top             =   1440
      Width           =   495
   End
   Begin VB.Shape Shape1 
      BackColor       =   &H000000C0&
      BorderColor     =   &H0000FFFF&
      FillColor       =   &H000000C0&
      FillStyle       =   0  'Solid
      Height          =   1575
      Left            =   7680
      Top             =   1320
      Width           =   135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Sub Command1_Click()
'January 31, 1996

'Dear Friends:

' Here is another another example of how to do some things with dice.
' My first fun 'Project' for beginners in Visual Basic
' can be found on AOL under my handle, Abracadab.
' It also delt with dice, but it strictly had to do with how
' to use a random number generator.  Now, we have taken that
' idea and explanded it to the current project.  This project
' was designed to not just use a number generator, but to add
' moveable graphics...and all of it is done without having to
' refer to the Visual Basic API to achieve it.  We have done
' it with the following code instead.  That's not to say that
' the API is not an excellent source of useful tools, but that
' beginners who don't know anything about API's find them rather
' hard to work with.

' I have intentionally kept the code in 16-bit so that you can
' develop the module (maybe) into something else for Windows 3.1
' users.  If you have Version 4.0 of Visual Basic, Professional
' Edition, you will be able to convert this module to a 32-bit
' application.  Of course, I leave that up to you.

' I have made every attempt to add as much documentation and
' explanation of what I have done here, so that you can follow
' the logic of it.  If you can think of a better way to do it
' without the Windows API, then Great!  More power to you.  I
' challenge all of you to make what I have done here better, faster,
' leaner, meaner and with cooler graphics if possible!

' This Project Module uses graphics to illustrate how you can
' move the graphics, and develop some random movements.  The idea
' is to shoot two dice out of a dice cup and throw them against
' a target wall (something like the game of Craps).  If you think
' about it, dice, when they are thrown against a wall, usually scatter
' in different directions after the wall is struck.  In order to
' achieve this randomness of position, we have had to develop some
' code to do it...i.e., it just dosen't happen by itself.

' Secondly, after the random positions are achieved, we must decide
' which die will have which random number face up.  The result is
' akin to the game of Craps.  But the point of the module is not
' to play a game of Craps. Rather, it is to illustrate how to move
' graphics without having to do some of the API calls that other
' authors seem to be stuck on these days...making it just one more
' thing beginners have to tackle.

' Of course, you will get to a point and a level of sophistication
' later on when you will want to use API's to achieve a better handle
' on things.  But for now, you can study how you might otherwise achieve
' the same without the API, albiet maybe in not such a sophisticated
' manner.

' Now, I have a 17 inch monitor.  So if the form is off your screen,
' you will have to adjust the form width accordingly.
' I suggest that you carefully look at my code before doing this,
' as it may change some things graphically.  I have estimated that
' the form will fit on a 14 incher, but you'll just have to give
' it that good ole' college try... dig in, and study my code!

' I suggest you go on ahead and print the code out on your printer.
' Just goto, File, then Print on the Visual Basic 4.0 Menu.

' Also, you will have to adjust the maximum value of Rollit
' which here is 7320, to the maximum width of whatever you set
' the form to on your screen.  In this case, don't forget to
' re-set the position of the red barrier (or wall) so that 'collision'
' occurs correctly.  Also, you will have to change the defaults I've
' set in the Form Open procedure.

' Oh, yes, one other thing...as usual, you can change anything you
' want to, modify it any way you like, and use the graphics, the code,
' or anything else you want...all without royalty.
' Study and enjoy...Drop me a line and let me know what you think.

' Sincerely......... >>> Jim Clark, Abracadab@AOL.COM <<<..............

'----------------------------------------------------------------------
'            ********  OK, Let's Get Going   *********
'----------------------------------------------------------------------
'  Variable and Constant Declarations - For Your Information
'     Picture1 = Die No. 1, Picture2 = Cup, Picture3 = Die No. 2
'     Shape1 = Backboard
'  Shake, Shakup, Shakedown, Rollit, Rollitback, UporDown, Angleitback,
'  Director, Rollit1, Angleitback1, A, B, C, and D are all Integers
'
'  I have purposely not set Option Explicit.
'-----------------------------------------------------------------------
'---- Load the dice cup, set the vertical position of the cup first ----

Picture2.Top = 1560
'----------------------------------------------------------------------
'If you have shot before, then pick the dice up and put them in the cup
Picture1.Visible = False
Picture3.Visible = False
'----------------------------------------------------------------------
'Set Default position of Dice 'in' the cup
Picture1.Left = 240
Picture3.Left = 240
'----------------------------------------------------------------------
'Load upright cup
' *********************************************************************
' Make sure you change the PATH of all graphics bitmap files to
' your current project PATH or when you compile at run time
' the program won't find the files.  Here you see my PATH where
' I put these files in developing this module on my computer.
' You should have the same path if you have Visual basic, but you
' will have to probably assign a different drive letter (yes, I have
' several hard drives on my computer!).
' *********************************************************************
Picture2.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Cup1.bmp")
'----------------------------------------------------------------------
'Ok, now shake the dice in the cup
    For Shake = 1 To 3
     For Shakeup = 1850 To 1560 Step -2 'Cause the cup to rise up a little
        Picture2.Top = Shakeup
     Next Shakeup
       For Shakedown = 1560 To 1850 Step 2
        Picture2.Top = Shakedown
       Next Shakedown
    Next Shake
'----------------------------------------------------------------------
'Tip the cup down and dump the dice out
Picture2.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Cup2.bmp")
'----------------------------------------------------------------------
'Set the vertical dice positions
Picture1.Top = 1860 'First Die
Picture3.Top = 1860 'Second Die
'----------------------------------------------------------------------
'Get Ready to Roll the Dice and Roll 'em
For Rollit = 240 To 7320 Step 300 'throw horizontal
      'Increase the step value to increase the dice velocity
       Picture1.Visible = True 'Make the first die visible
       Picture1.Left = Rollit
         Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7a.bmp")
         Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7b.bmp")
         Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7c.bmp")
         Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7a.bmp")
       If Rollit > 1000 Then 'Make the second die visible
          Picture3.Visible = True
            Picture3.Left = Rollit - 500
       'Notice that 500 is subtracted from the current Rollit Value
       'So that the second die will appear to lag just behind the
       'first die when they are rolling 'together'
            Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7a.bmp")
            Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7b.bmp")
            Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7c.bmp")
            Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7a.bmp")
             
    End If
       
Next Rollit
            
'------------------------------------------------------------------------
'Set the cup Upright after shooting the dice
Picture2.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Cup1.bmp")
'------------------------------------------------------------------------
'Ok, so the die gets to the end of the playing table...
'When the picture1.left value = 7320, then a collision occurs
'Make the die bounce back a little bit off of the table for effect
'In order to make this a little more interesting, then
'Make the distance and position it bounces a random value
'If you don't understand the structure of the Int statement
'Then go to VB HELP and look up Random Numbers, see: INT function
'Don't use the term 'Rollback' because this is a VB reserve word!
'And as we all know, dice do not always come back at us in straight
'lines, so we have to add a little angle to the rollitback for realism.
'-------------------------------------------------------------------------
  'First decide how far back the dice will roll to
      Randomize 'Seed the Int generator
      Rollitback = Int((7260 - 3500 + 1) * Rnd + 3500)
         'Decrease the 3500 number if you want it to come back even
         'further on the rollback
         'Next, decide whether this will be an up angle or down angle:
           Upordown = Int((3 * Rnd) + 1) 'The three possible conditions
            If Upordown = 1 Then 'Put an up angle on them
                Angleitback = Int((1860 - 100 + 1) * Rnd + 100)
               ElseIf Upordown = 2 Then 'Put a down angle on them
                Angleitback = Int((4650 - 500 + 1) * Rnd + 500)
               ElseIf Upordown = 3 Then
                Angleitback = 0 'Don't put an angle on the dice
             End If
           Director = Int((2 * Rnd) + 1) 'This decides whether values are
                                         'negative or positive
'--------------------------------------------------------------------------
 'Now, do some things to the dice to make it appear like
 'randomly bouncing back to various places on the playing board.
 For Rollit1 = 7320 To Rollitback Step -200
     If Picture1.Top > 4500 Then
        GoTo Endit 'Don't go off of the table
     End If
     Picture1.Left = Rollit1
       Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7a.bmp")
   If Director = 1 Then
     If Upordown = 1 Then
     Picture1.Top = Angleitback
        Angleitback = Angleitback + 10
            If Angleitback < 0 Then 'Don't let the die go off the table
               GoTo Endit
            End If
     End If
     If Upordown = 2 Then
     Picture1.Top = Angleitback
        Angleitback = Angleitback + 200
            If Angleitback < 0 Then 'Don't let the die go off the table
               GoTo Endit
            End If
     End If
                        ElseIf Director = 2 Then 'Yes, you are in a larger
                                                 'if-then-else statement!
     
     If Upordown = 1 Then
     Picture1.Top = Angleitback1
        Angleitback1 = Angleitback1 - 10
            If Angleitback1 < 0 Then 'Don't let the die go off the table
               GoTo Endit
            End If
     End If
     If Upordown = 2 Then
     Picture1.Top = Angleitback1
        Angleitback1 = Angleitback1 - 200
            If Angleitback1 < 0 Then 'Don't let the die go off the table
               GoTo Endit
            End If
     End If
'-------------------------------------------------------------------------
 End If
       Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7c.bmp")
       Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7a.bmp")
    
  
 Next Rollit1 'Whow - don't forget you are in a big loop!
'-------------------------------------------------------------------------
'Now check to make sure that the die do not 'cover' or 'hide'
              'one another by being too close to each other
              'If so, then move the second die a little
              B% = (Val(Picture1.Left) - Val(Picture3.Left))
             
              
              'Back the die off the border
              If Val(Picture1.Left) Or Val(Picture3.Left) >= 7680 Then
                 Picture1.Left = Val(Picture1.Left) - 200
                 Picture3.Left = Val(Picture3.Left) - 200
              End If
              
              'Back them from each other if too close
              If (Val(Picture1.Left) - Val(Picture3.Left)) <= 100 Then
                A% = Val(Picture3.Left) - 500
                Picture3.Left = A%
              End If
              
              'If the two die exactly hide each other then
              'No! we don't allow die to stack on top of each other!
              
                A% = Picture3.Left
                C% = Picture1.Left
                D% = (A% - C%)
                If D% = 20 Or D% = -20 Then
                   Picture3.Left = Picture3.Left - 500
                ElseIf D% = 30 Or D% = -30 Then
                   Picture3.Left = Picture3.Left - 500
                ElseIf D% = 40 Or D% = -40 Then
                   Picture3.Left = Picture3.Left - 500
                ElseIf D% = 50 Or D% = -50 Then
                   Picture3.Left = Picture3.Left - 500
                ElseIf D% = 60 Or D% = -50 Then
                   Picture3.Left = Picture3.Left - 500
                ElseIf D% = 70 Or D% = -70 Then
                   Picture3.Left = Picture3.Left - 500
                ElseIf D% = 180 Or D% = -180 Then
                  Picture3.Left = Picture3.Left - 500
                End If
'-----------------------------------------------------------------------

Endit:
'OK, so now ... finally, decide which die are going to occur and then
'we end the roll.  For beginners, remember that programming in the
'basic language is position sensitive...you have to put the right code
'in the right place to make the right things happen.

 
             FinalDie1 = Int((6 * Rnd) + 1)
             FinalDie2 = Int((6 * Rnd) + 1)
             
  'Choose the right die for Die No. 1
  If FinalDie1 = 1 Then
      Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die12a.bmp")
  ElseIf FinalDie1 = 2 Then
      Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die11a.bmp")
  ElseIf FinalDie1 = 3 Then
      Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die9a.bmp")
  ElseIf FinalDie1 = 4 Then
      Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7a.bmp")
  ElseIf FinalDie1 = 5 Then
      Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die8a.bmp")
  ElseIf FinalDie1 = 6 Then
      Picture1.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die10a.bmp")
  End If
  
  'Choose the right die for Die No. 2
  If FinalDie2 = 1 Then
      Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die12a.bmp")
  ElseIf FinalDie2 = 2 Then
      Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die11a.bmp")
  ElseIf FinalDie2 = 3 Then
      Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die9a.bmp")
  ElseIf FinalDie2 = 4 Then
      Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die7a.bmp")
  ElseIf FinalDie2 = 5 Then
      Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die8a.bmp")
  ElseIf FinalDie2 = 6 Then
      Picture3.Picture = LoadPicture("E:\VB\Bitmaps\Assorted\Die10a.bmp")
  End If


'Make Sure the Border is re-drawn at end of play

  Shape1.BorderStyle = 1
  Shape1.BorderWidth = 1
  Shape1.FillColor = &HC0&
  Shape1.FillStyle = 0
  Shape1.BackColor = &HC0&
  Shape1.BorderColor = &HFFFF&
'-------------------------------------------------------------------------
'Ok, Done!
End Sub

Private Sub Timer1_Timer()

End Sub


Private Sub Form_Load()
Form1.Width = 8085
Form1.Top = 1170
Form1.Left = 795
Picture1.Top = 1860
Picture2.Top = 1860
Picture3.Top = 1860

End Sub


