VERSION 2.00
Begin Form frmPrinter 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Output Selection"
   ClientHeight    =   2436
   ClientLeft      =   3972
   ClientTop       =   2664
   ClientWidth     =   2700
   Height          =   2880
   Left            =   3912
   LinkTopic       =   "Form4"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2436
   ScaleWidth      =   2700
   Top             =   2280
   Width           =   2820
   Begin SSPanel pnlRecSelect 
      Alignment       =   0  'Left Justify - TOP
      BevelInner      =   1  'Inset
      BorderWidth     =   1
      Caption         =   "Record Selection:"
      ForeColor       =   &H00FF0000&
      Height          =   852
      Left            =   108
      TabIndex        =   6
      Top             =   984
      Width           =   2496
      Begin ComboBox cmboRecSelect 
         Height          =   288
         Left            =   180
         Sorted          =   -1  'True
         Style           =   2  'Dropdown List
         TabIndex        =   7
         Top             =   312
         Width           =   2076
      End
   End
   Begin SSPanel Panel3D2 
      Alignment       =   0  'Left Justify - TOP
      BevelInner      =   1  'Inset
      BorderWidth     =   1
      Caption         =   "Output to:"
      ForeColor       =   &H00FF0000&
      Height          =   852
      Left            =   108
      TabIndex        =   3
      Top             =   96
      Width           =   2496
      Begin SSOption optAction 
         Caption         =   "Default Printer"
         ForeColor       =   &H00800000&
         Height          =   252
         Index           =   1
         Left            =   660
         TabIndex        =   5
         TabStop         =   0   'False
         Top             =   504
         Width           =   1700
      End
      Begin SSOption optAction 
         Caption         =   "Preview Window"
         ForeColor       =   &H00800000&
         Height          =   204
         Index           =   0
         Left            =   660
         TabIndex        =   4
         Top             =   264
         Value           =   -1  'True
         Width           =   1700
      End
   End
   Begin SSPanel Panel3D1 
      Align           =   2  'Align Bottom
      Height          =   492
      Left            =   0
      TabIndex        =   0
      Top             =   1944
      Width           =   2700
      Begin SSCommand cmdAction 
         BevelWidth      =   1
         Caption         =   "&Close"
         Height          =   444
         Index           =   1
         Left            =   1356
         TabIndex        =   2
         Top             =   24
         Width           =   1332
      End
      Begin SSCommand cmdAction 
         BevelWidth      =   1
         Caption         =   "&Go"
         Height          =   444
         Index           =   0
         Left            =   24
         TabIndex        =   1
         Top             =   24
         Width           =   1332
      End
   End
   Begin CrystalReport Report1 
      BoundReportFooter=   0   'False
      BoundReportHeading=   ""
      Connect         =   ""
      CopiesToPrinter =   1
      Destination     =   0  'Window
      GroupSelectionFormula=   ""
      Left            =   36
      PrintFileName   =   ""
      PrintFileType   =   2  'Text
      ReportFileName  =   ""
      ReportSource    =   0  'Report File
      SelectionFormula=   ""
      SessionHandle   =   0
      Top             =   12
      UserName        =   ""
      WindowBorderStyle=   2  'Sizable
      WindowControlBox=   -1  'True
      WindowHeight    =   300
      WindowLeft      =   100
      WindowMaxButton =   -1  'True
      WindowMinButton =   -1  'True
      WindowParentHandle=   0
      WindowTitle     =   ""
      WindowTop       =   100
      WindowWidth     =   480
   End
End
Option Explicit
DefInt A-Z

Dim States() As String

Sub cmdAction_Click (Index As Integer)

  Dim x As Integer

  Select Case Index
    Case 0
      If Len(cmboRecSelect.Text) = 0 Then
        Message$ = "Please select one of the States, or All States."
        Style = 32
        Title$ = "RECORD SELECTION"
        MsgBox Message$, Style, Title$
        Exit Sub
      End If
      For x = 0 To 1
        If optAction(x) = True Then
          Call PrintReport(x)
        End If
      Next
    Case 1
      Unload Me
  End Select

End Sub

Sub Form_Activate ()

  Screen.MousePointer = DEFAULT

End Sub

Sub Form_Load ()

  Dim TempState As String, x As Integer, z As Variant
  ReDim States(0) As String

  Call CenterForm(Me)
  
  'rather than use another Data control, just read the items from
  'the one on frmPublishers
  cmboRecSelect.AddItem " All States"
  ds.MoveFirst
  Do
    z = ds("State")
    If Len(z) > 0 Then
      TempState = ds("State")
      For x = 0 To UBound(States)
        If TempState = States(x) Then Exit For
      Next
      If x > UBound(States) Then
        ReDim Preserve States(x)
        States(x) = ds("State")
        cmboRecSelect.AddItem (States(x))
      End If
    End If
    ds.MoveNext
  Loop Until ds.EOF

End Sub

Sub PrintReport (Selection As Integer)

  Report1.DataFiles(0) = CommonDir$ & "biblio.mdb"
  Report1.ReportFileName = CommonDir$ & "report1.rpt"
  
  Report1.Formulas(0) = "CompanyName='COMPANY NAME GOES HERE'"
  Report1.Formulas(1) = "ReportName='LITERAL REPORT NAME'"
  Report1.Formulas(2) = "Title1='Index'"
  Report1.Formulas(3) = "Title2='Short Name'"
  Report1.Formulas(4) = "Title3='Publisher Name'"
  Report1.Formulas(5) = "Title4='City'"
  Report1.Formulas(6) = "Title5='State'"
  Report1.Formulas(7) = "Title6='Zip'"
  Report1.Formulas(8) = "Title7='Phone'"
  Report1.Formulas(9) = "Title8='FAX'"
  
  Report1.SelectionFormula = ""
  If cmboRecSelect <> " All States" Then
    Report1.SelectionFormula = "{PUBLISHERS.State}= " & apos & Trim$(cmboRecSelect) & apos
  End If
  
  Select Case Selection
    Case 0
      Report1.WindowTitle = "TITLE OF YOUR REPORT"
      Report1.WindowControlBox = True
      Report1.WindowMaxButton = True
      Report1.WindowMinButton = True
      '-- sets up preview to occupy 90% of the screen, and to be centered.
      Report1.WindowHeight = (Screen.Height * .9) \ Screen.TwipsPerPixelX
      Report1.WindowWidth = (Screen.Width * .9) \ Screen.TwipsPerPixelY
      Report1.WindowLeft = (Screen.Width * .05) \ Screen.TwipsPerPixelX
      Report1.WindowTop = (Screen.Height * .05) \ Screen.TwipsPerPixelY
      Report1.Destination = 0
    Case 1
      Report1.Destination = 1
    Case Else
  End Select

  Screen.MousePointer = HOURGLASS
  Report1.Action = 1
  DoEvents
  Screen.MousePointer = DEFAULT

End Sub

