Attribute VB_Name = "Module1"

'''''''''''''required for On/OffTop Subs:
Declare Sub SetWindowPos _
Lib "user32" (ByVal hwnd _
As Integer, ByVal hWndInsertAfter As Integer, _
ByVal X As Integer, ByVal Y As Integer, _
ByVal cx As Integer, ByVal cy As Integer, _
ByVal wFlags As Integer)
  
'''''''''''''' required for Play sub:
Private Declare Function mciSendString _
Lib "winmm.dll" Alias "mciSendStringA" _
(ByVal lpstrCommand As String, _
ByVal lpstrReturnString As String, _
ByVal uReturnLength As Integer, _
ByVal hWndCallback As Integer) As Long

'''''''''''''''
Declare Function mciGetErrorString _
Lib "winmm.dll" Alias "mciGetErrorStringA" _
(ByVal wError As Long, _
ByVal lpstrBuffer As String, _
ByVal uLength As Integer) As Integer

Public a As Long
Public sAlias As String * 5

'''''''''''''''' required for GetCursorPos
'''''''''''''''' not yet used by any procedures
Type PointAPI
    X As Long
    Y As Long
End Type
Public Pnt As PointAPI
Declare Function GetCursorPos Lib _
"user32" (lpPoint As PointAPI) As Long

''''''''''''' required for GetActiveWindow
''''''''''''' not yet used by Any Procedures
Declare Function GetActiveWindow Lib "user32" () As Long

''''''''' required for GetChildInfo sub
Declare Function FindWindow Lib "user32" Alias "FindWindowA" _
(ByVal lpClassName As String, _
ByVal lpWindowName As String) As Long

Declare Function GetWindow Lib "user32" _
(ByVal hwnd As Long, _
ByVal wCmd As Long) As Long

Declare Function GetClassName Lib "user32" Alias "GetClassNameA" _
(ByVal hwnd As Long, _
ByVal lpClassName As String, _
ByVal nMaxCount As Long) As Long

Public Const GW_HWNDFIRST = 0
Public Const GW_HWNDLAST = 1
Public Const GW_HWNDNEXT = 2
Public Const GW_CHILD = 5

Type api_info
     hw As Long '  hWnd
     cn As String ' Classname
End Type

Public sChildClassName As String * 200

''''''''''''' required for VPixsFromEtc subs
'which Create Virtual Pictures in Memory
'you must Refrence Standard OLE types for this
'to work or ERROR : User-Defined Type Not Defined
'ALSO NOTE: Use ClearVPix at some point to Clear
'memory

Public MyPixs() As StdPicture



Public Sub CheckMciError(a)

'get and display MCI Error

Dim ReturnString As String * 128
ReturnString = Space(128)

ErrorRet% = mciGetErrorString(a, ReturnString, Len(ReturnString))
    
If ErrorRet% = 1 Then
   res% = MsgBox _
   (ReturnString, vbExclamation + vbOKOnly, "MCI Error Returned")
                End If

End Sub
Public Sub VPixFromFile(iIndex As Integer, sPixFile As String)

' example : VPixFromFile 0,"C:\VB\CRATR256.BMP"
'See VPixsClear sub

ReDim Preserve MyPixs(iIndex)

Set MyPixs(iIndex) = LoadPicture(sPixFile)

End Sub
Public Sub StopPlay()

'stops all file that are playing, if any
'example StopPlay

ReturnString = Space(128)

For I% = 1 To 2
 If I% = 1 Then CommandString = "stop " & sAlias _
           Else CommandString = "close " & sAlias
a = mciSendString _
(CommandString, ReturnString, Len(ReturnString), 0)
Next I%

sAlias = "     "

End Sub
Public Sub Play(sFilename As String)

'example Play "C:\MyWav.wav" or Play "C:\MyMid.mid" or
'Play "C:\MyAvi.avi" ...... avi needs a little more work :)
'you can actually play a mid and wav at same time,
'just use Play twice , but dont Play avi and wav,
'or 2 of the same at same time .. wont work

Dim sPlayStyle As String
ReturnString = Space(128)

Select Case UCase(Right$(sFilename, 3))
 Case Is = "AVI"
  sPlayStyle = " type mciavi alias "
  sAlias = "myavi"
 Case Is = "MID"
  sPlayStyle = " type sequencer alias "
  sAlias = "mymid"
 Case Is = "WAV"
  sPlayStyle = " type waveaudio alias "
  sAlias = "mywav"
 Case Else
  Exit Sub
End Select

For I% = 1 To 3
 Select Case I%
  Case 1
   CommandString = "close " & sAlias
  Case 2
   CommandString = "open " & sFilename & sPlayStyle & sAlias
  Case 3
   CommandString = "play " & sAlias & " from 1"
 End Select
 
 a = mciSendString _
 (CommandString, ReturnString, Len(ReturnString), 0)

 If a <> 0 Then CheckMciError (a)
 
Next I%


End Sub



Public Sub Center(frm As Form)

' center the Calling Form
' example: Center Me < use in Form_Load event

frm.Move (Screen.Width - frm.Width) / 2, _
         (Screen.Height - frm.Height) / 2

End Sub

Public Sub Wait(delay As Single)

'Delay app the selected no. of seconds
'example  Wait 3.5
'app will loop here for 3.5 seconds

starttime! = Timer
Do Until Timer >= starttime! + delay
DoEvents
Loop

End Sub

Public Sub OnTop(hwnd As Long)

'put hWnd  always on top
'example:
'    Sub Form1_Load()
'    OnTop hWnd
'    End Sub

'NOTE: before showing additional forms,
'use OffTop to return the Main or calling
'form to normal.Ex:
                    'Sub mnuAbout_Click()
                    '
                    'OffTop hWnd
                    'frmAbout.Show vbModal
                    'OnTop hWnd
                    '
                    'End Sub
'
' ALSO NOTE:  OnTop will not always work in vb design
'enviornment, but will work when app is compiled to an EXE
'(this is due to the MDI nature of the VB IDE)
'
' alot of explanation for 1 line of Code !!!! :)

Call SetWindowPos(hwnd, -1, 0, 0, 0, 0, &H2 Or &H1)

End Sub

Public Sub OffTop(hwnd As Long)

'take hWnd OFF always on top
'example:
'    Sub Form1_Load()
'    OffTop hWnd
'    End Sub

Call SetWindowPos _
(hwnd, -2, 0, 0, 0, 0, &H2 Or &H1)

End Sub










Public Function FindFile(sPath As String) As Boolean
'
'Checks for an existing File,
'returns True or False
'examples:
'If FindFile(Text1.Text) Then Label1 = "YES"
'If Not FindFile(Text1.Text) Then Label1 = "NO"

If Dir(sPath) = TrimPath(sPath) Then ' uses TrimPath Functio
     FindFile = True
                                Else
     FindFile = False
                                End If



End Function

Public Sub SaveString(sText As String, sPath As String)

'Save sText as a NEW Text File, sPath
'example: SaveString thistxt$, "C:\NewFile.txt"
'caution if file already exists it will be replaced,
'use AddString procedure to Append an Existing .txt File

Dim fno As Integer

fno = FreeFile
Open sPath For Output As #fno
Write #fno, sText
Close #fno

End Sub

Public Function ReadString(sPath As String) As String

'load a Text File into ReadString
' example MyTextFile$ = ReadString("C:\MyText.txt")

Dim fno As Integer

fno = FreeFile
Open sPath For Input As #fno
Do Until EOF(fno)
 Input #fno, txt$
 ReadString = ReadString & txt$
Loop
Close #fno

End Function

Public Sub AddString(sText As String, sPath As String)

' Add New Line(s) to an existing  Text File
'
'example: AddString sThisTxt$, "C:\NewFile.txt"
'If file dosnt exists it will be created,
'use AddString procedure to APPEND an Existing .txt File,
'use SaveString procedure to create a NEW .txt File

Dim fno As Integer

fno = FreeFile
Open sPath For Append As #fno
Write #fno, sText
Close #fno

End Sub

Public Function ErrBox(iErr As Integer, sError As String, sMsgTitle As String, sInfo As String) As Integer

'This Procedure is still a "work in progress"
' alot of ERR's left to handle! . I also hope to make
' most of the arguments optional
'
'example iResponse% = ErrBox(Err,Error$,sMsgBoxTitle$,sAdditionalInfo$)
'
' If you can use this Function go ahead, too hard to
' explain !  :(

Dim iErrType As Integer ' added to msgbox return value
Dim iMsgType As Integer ' msgbox icon and button config
Dim sMsgText As String  ' msgbox text

' if sMsgTitle is passed as "", the default is used

If sMsgTitle = "" Then sMsgTitle = App.Title

' sInfo can be used to pass additional information
' to the ErrBox function, such as the filename, or it
' can be used for predefined overrides,
' Ex: OFF while debugging, or IGNore a particular Error

Select Case sInfo '**********************************

 Case Is = "IGN"   'IGN = bypass ErrBox completly...
  ErrBox = 0       '
  Exit Function

 Case Is = "OFF"   'OFF = ErrBox error handling off..
  sMsgText = "ERR # " & Str(iErr) & vbCrLf & sError
  iMsgType = vbOKOnly
  sMsgTitle = "ErrBox is OFF"
  iErrType = 0
  GoTo Skip_ErrBox_Handling

End Select         '**********************************

Select Case iErr   '**********************************

 Case 52, 64   'bad File name or number...............
  iErrType = 10
  iMsgType = vbExclamation + vbOKOnly
  If sInfo = "" Then
   sMsgText = "Please Use a Proper File Name." & vbCrLf & _
              "  That File Name is Illegal."
  Else
   sMsgText = "Please Use a Proper File Name." & vbCrLf & _
              sInfo & vbCrLf & _
              "  Is an Illegal Filename."
  End If
  
 Case 54       'bad File Mode..........................
  iErrType = 10
  iMsgType = vbExclamation + vbOKOnly
   If sInfo = "" Then
   sMsgText = "  That File Cannot be Used in This Manner. "
  Else
   sMsgText = "The File: " & sInfo & vbCrLf & _
              Space(Int(Len(sInfo) / 3)) & _
              "Cannot be Used in This Manner."
  End If
  
 Case 55       'file already open.......................
   iErrType = 10
   iMsgType = vbExclamation + vbOKOnly
  If sInfo = "" Then
   sMsgText = " That File is Already in Use."
  Else
   sMsgText = " The File: " & sInfo & vbCrLf & _
                "Is Already in Use."
  End If
  
 Case 61       'disk full...............................
  iErrType = 10
  iMsgType = vbCritical + vbRetryCancel
  If sInfo = "" Then
   sMsgText = " That Disk is Full."
  Else
   sMsgText = " The Disk in Drive " & UCase(Left(sInfo, 1)) & _
   " Is Full.           "
  End If
  
 Case 68       'device unavilable........................
  iErrType = 10
  iMsgType = vbCritical + vbRetryCancel
  sMsgText = "  That Device is unavilable. "
  
 Case 71       'disk not ready............................
  iErrType = 10
  iMsgType = vbCritical + vbRetryCancel
  If sInfo = "" Then
   sMsgText = "Please Check Your Drive," & vbCrLf & _
              " The Disk is Not Ready."
  Else
   sMsgText = "Please check Drive " & UCase(Left(sInfo, 1)) & _
              vbCrLf & "The Disk is not Ready."
  End If

End Select '***********************************************

Skip_ErrBox_Handling:

sMsgText = AlignText(sMsgText) ' Uses AlignText Function

ErrBox = iErrType + MsgBox(sMsgText, iMsgType, sMsgTitle)

End Function



Public Function AlignText(sText As String) As String

'Align(pad Lines) a Sting with multi lines
'mainly used for MsgBox, this sub will align
'the lines in a multiline txt string.
'example sAlignedText$ = AlignText(sUnAlignedTxt$)
'

Dim aAT1() As String
Dim aAT2() As String
Dim sLine As String
Dim iLL As Integer  ' Longest Line

' build aAT1() from sText [- vbLf's]
For I% = 0 To Len(sText)
 ReDim Preserve aAT1(I%)
 If Mid$(sText, I% + 1, 1) <> vbLf Then _
  aAT1(I%) = Mid$(sText, I% + 1, 1)
Next I%

'build aAT2()[lines] from aAT1()[char's]
I% = 0
Do Until I% = UBound(aAT1)
 If aAT1(I%) = vbCr Then
 ReDim Preserve aAT2(J%)
  aAT2(J%) = sLine
  J% = J% + 1
  sLine = ""
 Else
  sLine = sLine + aAT1(I%)
 End If
 I% = I% + 1
Loop

' add LAST Line to aAT2
 ReDim Preserve aAT2(J%)
  aAT2(J%) = sLine

' get Longest Line Length
For I% = 0 To J%
 If Len(aAT2(I%)) > iLL Then iLL = Len(aAT2(I%))
Next I%
 
'Pad aAT2() lines & build return string
For I% = 0 To UBound(aAT2)
 If Len(aAT2(I%)) > 0 Then _
 aAT2(I%) = Space(Int(iLL - Len(aAT2(I%))) / 2) & aAT2(I%)
 
AlignText = AlignText & aAT2(I%) & vbCrLf

Next I%
 
End Function





Public Sub Main()

End Sub



Public Sub GetChildInfo(tApiInfo() As api_info, vClsNameORhWnd As Variant)

' This sub requires the User Defined Type api_info to be Declared
'as an Array and then passed to the sub, where it is populated with the
'classname (.cn) and hWnd (.hw) of every child of a parent window.
' You must supply the UDT array AND the parent classname OR hWnd.
'
'EXAMPLE:
'Private Sub Form_Click()
'Dim Test() As api_info
'GetChildInfo Test(), "ExploreWClass"
'
'OR: GetChildInfo Test(), xplor_hWnd
'(assuming xplor_hWnd = Explorers current hWnd)
'
'For I% = 0 To UBound(Test)
'Print "Classname :" & Test(I%).cn & "  hWnd:"; Test(I%).hw
'Next I%
'End Sub

Dim lPrntHWnd As Long

vt% = VarType(vClsNameORhWnd)
If vt% = vbString Then _
lPrntHWnd = FindWindow(CStr(vClsNameORhWnd), vbNullString)

If vt% = vbLong Then lPrntHWnd = CLng(vClsNameORhWnd)

ReDim tApiInfo(0)

tApiInfo(0).hw = GetWindow _
(lPrntHWnd, GW_CHILD)

ClsNmLen% = GetClassName _
(tApiInfo(0).hw, sChildClassName, Len(sChildClassName))
tApiInfo(0).cn = Left(sChildClassName, ClsNmLen%)

Do Until tApiInfo(cnt%).hw = 0
 cnt% = cnt% + 1
 ReDim Preserve tApiInfo(cnt%)
 
 tApiInfo(cnt%).hw = GetWindow _
 (tApiInfo(cnt% - 1).hw, GW_HWNDNEXT)
 
 ClsNmLen% = GetClassName _
 (tApiInfo(cnt%).hw, sChildClassName, Len(sChildClassName))
 tApiInfo(cnt%).cn = Left(sChildClassName, ClsNmLen%)

Loop
 
If UBound(tApiInfo) > 0 Then ReDim Preserve tApiInfo(cnt% - 1)
  
End Sub

Public Sub VPixFromPix(iIndex As Integer, pPix As Picture)

' example : VPixFromPix 0, Images(0).Picture
' see VPixsClear sub

ReDim Preserve MyPixs(iIndex)

Set MyPixs(iIndex) = pPix

      
End Sub

Public Sub VPixsClear()

'important to remember to clear object/array from
'memory when done with it !!!
'example: VPixsClear

'an error occurs if no VPixs
On Error GoTo Error_VPixsClear

For I% = 0 To UBound(MyPixs)
Set MyPixs(I%) = Nothing
Next I%
Erase MyPixs

Exit Sub

Error_VPixsClear:
End Sub

Public Function GetListIndex(cListControl As Control, sItemText As String) As Integer

'returns ListIndex of an Item in a list,
'supply control name (ListBox or ComboBox)
'and Item Text string
'EXAMPLE: Label1 = GetListIndex(Combo1,"Is Item?")
' returns -2 if match not found

With cListControl
 For I% = 0 To .ListCount - 1
  If InStr(sItemText, .List(I%)) Then
   GetListIndex = I%   ' match found
   Exit Function
  End If
 Next I%
End With
GetListIndex = -2  '  no match found

End Function

Public Function TrimPath(sPath As String, Optional vStyle) As String

'Performs a Fix or Trim on a Supplied Path String
's$ = "C:\Example\Path\Filename"
'x$ = TrimPath(s$) [no style supplied]  x$ = "Filename"
'x$ = TrimPath(s$,"\")[add \ if needed] x$ = "C:\Example\Path\Filename\"
'x$ = TrimPath(s$,"D")                  x$ = "C:"
'x$ = TrimPath(s$,"D\")                 x$ = "C:\"
'x$ = TrimPath(s$,"P")                  x$ = "C:\Example\Path"
'x$ = TrimPath(s$,"P\")                 x$ = "C:\Example\Path\"

If Not IsMissing(vStyle) And CStr(vStyle) = "\" Then
 If Right$(sPath, 1) = "\" Then TrimPath = sPath Else TrimPath = sPath & "\"
 Exit Function
End If

For I% = Len(sPath) To 1 Step -1
 If InStr(I%, sPath, "\", 1) = I% Then
  bIsBkSlsh = True
  Exit For
 End If
Next I%
If Not bIsBkSlsh Then Exit Function

If IsMissing(vStyle) Then                  'default trim
 TrimPath = Right$(sPath, Len(sPath) - I%) 'returns just Filename
 Exit Function
End If

Select Case UCase(CStr(vStyle))
 Case Is = "D"                     'returns Drive:
  TrimPath = Left$(sPath, 2)
 Case Is = "D\"                    'returns Drive:\
  TrimPath = Left$(sPath, 3)
 Case Is = "P"                     'returns Drive:\Path
  TrimPath = Left$(sPath, I% - 1)
 Case Is = "P\"                    'returns Drive:\Path\
  TrimPath = Left$(sPath, I%)
End Select

End Function


