VERSION 2.00
Begin Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5820
   ClientLeft      =   1095
   ClientTop       =   1770
   ClientWidth     =   7365
   Height          =   6510
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   5820
   ScaleWidth      =   7365
   Top             =   1140
   Width           =   7485
   Begin Menu mnuOrderForm 
      Caption         =   "Order Form"
   End
End
Dim CRLF As String

Function FileExists (filename As String) As Integer
    'This sub checks for the existance of any filename passed to it

    'Make sure that a filename was passed or the function
    'will return TRUE since it will find any file that exists
    'in the current directory.
    If Len(filename) = 0 Then
        FileExists = False
        Exit Function
    End If
    
    If Len(Dir$(filename)) Then
        FileExists = True
    Else
        FileExists = False
    End If
End Function

Sub Form_Load ()
    
    CRLF = Chr$(13) + Chr$(10)
    'The code below is used only in the demo version
    Verification = VerifyLicense()
    Select Case Verification
    Case False
        frmOrderForm.Show 1
        Close
        End
    End Select

End Sub

Sub mnuOrderForm_Click ()
    frmOrderForm.Show 1
End Sub

Function VerifyLicense ()
On Error GoTo DateError

    'This sub will verify that 30 days have not passed
    'since the program was installed and that the date
    'in the license file has not been altered.


    'First verify that the license file exists in the program directory
    If Not FileExists(App.Path + "\demo.lic") Then
        Msg$ = UCase$(App.Path + "\demo.lic") + CRLF + CRLF
        Msg$ = Msg$ + "File Not Found" + CRLF + CRLF
        Msg$ = Msg$ + "This file must exist in the above directory.  Please "
        Msg$ = Msg$ + "re-run Setup to properly install Program."
        MsgBox Msg$, 48
        End
    End If

    VerifyLicense = True
    
    'Get the coded date from the license file
    FileNum = FreeFile
    Open App.Path + "\demo.lic" For Input As FileNum
    'We're only interested in the last line of the file that
    'contains the date, but the file is so small, it's easier
    'to just loop through the previous lines.
    Do Until EOF(FileNum)
        Line Input #FileNum, Temp$
    Loop
    Close FileNum

    For I = 1 To Len(Temp$)
        Char$ = Mid$(Temp$, I, 1)
        UnCodedDate = UnCodedDate + Chr$(Asc(Char$) - 190)
    Next I
    
    FD = CVDate(UnCodedDate)

    If (FD + 30) >= Date Then
        Select Case Abs((FD + 30) - Date)
            Case 0
                Msg$ = "Today is the LAST day of the evaluation period "
                Msg$ = Msg$ + "for this demo version of Program." + CRLF + CRLF
            Case 1
                Msg$ = "There is " + Str$(Abs(FD + 30 - Date)) + " day "
                Msg$ = Msg$ + "remaining in the evaluation period for this demo "
                Msg$ = Msg$ + "version of Program." + CRLF + CRLF
            Case 30
                '1st day of evaluation period
                Msg$ = "Thank you for ordering this demo version of Program.  " + CRLF + CRLF
                Msg$ = Msg$ + "You have 30 days to use and evaluate this program to "
                Msg$ = Msg$ + "determine its usefulness to your company.  "
                Msg$ = Msg$ + "Program will not run after the 30 day evaluation "
                Msg$ = Msg$ + "period has expired.  A box will be displayed each time "
                Msg$ = Msg$ + "Program is started, indicating the number of days "
                Msg$ = Msg$ + "remaining in the evaluation period."
                MsgBox Msg$, 64
            Case Else
                Msg$ = "There are " + Trim$(Str$(Abs(FD + 30 - Date))) + " days "
                Msg$ = Msg$ + "remaining in the evaluation period for this demo "
                Msg$ = Msg$ + "version of Program." + CRLF + CRLF
        End Select
        If Abs((FD + 30) - Date) <> 30 Then
            Msg$ = Msg$ + "If you have found Program to be useful, "
            Msg$ = Msg$ + "and wish to continue using it beyond the evaluation period, "
            Msg$ = Msg$ + "please fill out the online order form, enclose a check or money order "
            Msg$ = Msg$ + "for the correct amount and mail to the address which appears on the "
            Msg$ = Msg$ + "order form." + CRLF + CRLF
            Msg$ = Msg$ + "Thank you for ordering this demo version of Program!"
            MsgBox Msg$, 64, "Evaluation Days Remaining"
        End If
    Else
        Msg$ = "The 30 day evaluation period for Program has expired." + CRLF + CRLF
        Msg$ = Msg$ + "If you have found Program to be useful, "
        Msg$ = Msg$ + "and wish to continue using it beyond the evaluation period, "
        Msg$ = Msg$ + "please fill out the online order form, enclose a check or money order "
        Msg$ = Msg$ + "for the correct amount and mail to the address which appears on "
        Msg$ = Msg$ + "order form." + CRLF + CRLF
        Msg$ = Msg$ + "Thank you for ordering this demo version of Program!"
        MsgBox Msg$, 16, "Evaluation Period Expired"
        VerifyLicense = False
    End If
    Exit Function

DateError:
    Msg$ = "An error occured while verifying the license file.  "
    Msg$ = Msg$ + "Program must be re-installed."
    MsgBox Msg$, 48
    End
    Exit Function

End Function

