VERSION 4.00
Begin VB.Form Example1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Child Windows"
   ClientHeight    =   5760
   ClientLeft      =   1275
   ClientTop       =   1920
   ClientWidth     =   6675
   Height          =   6165
   Icon            =   "EX1.frx":0000
   Left            =   1215
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5760
   ScaleWidth      =   6675
   ShowInTaskbar   =   0   'False
   Top             =   1575
   Width           =   6795
   Begin VB.CommandButton cmdChild2 
      Caption         =   "&List Children"
      Height          =   375
      Left            =   5280
      TabIndex        =   6
      Top             =   4680
      Width           =   1095
   End
   Begin VB.ListBox lstChild 
      Height          =   1815
      Left            =   240
      TabIndex        =   4
      Top             =   2760
      Width           =   6135
   End
   Begin VB.CommandButton cmdChild 
      Caption         =   "&List Children"
      Height          =   375
      Left            =   5280
      TabIndex        =   3
      Top             =   1680
      Width           =   1095
   End
   Begin VB.CommandButton cmdReload 
      Caption         =   "&Refresh"
      Height          =   375
      Left            =   4200
      TabIndex        =   2
      Top             =   1680
      Width           =   975
   End
   Begin VB.ListBox lstWindows 
      Height          =   1035
      Left            =   240
      TabIndex        =   0
      Top             =   480
      Width           =   6135
   End
   Begin VB.Label Label3 
      Caption         =   $"EX1.frx":000C
      Height          =   975
      Left            =   240
      TabIndex        =   7
      Top             =   4680
      Width           =   4935
   End
   Begin VB.Label Label2 
      Caption         =   "Handle     Window Class Name           Window Text"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   2520
      Width           =   6135
   End
   Begin VB.Line lnSep 
      X1              =   240
      X2              =   6240
      Y1              =   2280
      Y2              =   2280
   End
   Begin VB.Label Label1 
      Caption         =   "Select a Window:"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   240
      Width           =   6135
   End
End
Attribute VB_Name = "Example1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
   ' The hWindow and hChildren Arrays hold
   ' the handles of all the windows in the ListBoxes
   #If Win32 Then
   Dim hWindow(999) As Long
   Dim hChild() As Long
   #Else
   Dim hWindow(999) As Integer
   Dim hChild() As Integer
   #End If
   
   ' API Declarations
   #If Win32 Then
   Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
   #Else
   Private Declare Function GetWindow Lib "User" (ByVal hWnd As Integer, ByVal wCmd As Integer) As Integer
   #End If
   
   ' GetWindow Constants
   Private Const GW_CHILD = 5
   Private Const GW_HWNDFIRST = 0
   Private Const GW_HWNDLAST = 1
   Private Const GW_HWNDNEXT = 2
   Private Const GW_HWNDPREV = 3
   Private Const GW_MAX = 5
   Private Const GW_OWNER = 4

#If Win32 Then
Private Sub ListChildWindows(ByVal hWnd As Long)
#Else
Private Sub ListChildWindows(ByVal hWnd As Integer)
#End If
   ' Declares
   Dim sPrefix As String
   
   ' Clear the List and Disable cmdChild2
   lstChild.Clear
   cmdChild2.Enabled = False
   
   ' List the Child Windows
   For i = 0 To GetChildArray(hChild, hWnd) - 1
      ' If the window has children, display a "+" sign
      If GetChildCount(hChild(i)) > 0 Then
         sPrefix = "+ "
      Else
         sPrefix = "   "
      End If
      
      ' Add the item
      lstChild.AddItem sPrefix & hChild(i) & Chr$(9) & _
                    GetWindowClassName(hChild(i)) & Chr$(9) & _
                    WindowText(hChild(i))
   Next i
End Sub

Private Sub cmdChild_Click()
   ' Exit if No item is selected
   If lstWindows.ListIndex = -1 Then
      MsgBox "Please select a window first!", vbExclamation, "Sorry"
      Exit Sub
   End If
   
   ' Show bottom of form
   Me.Height = 6200
   
   ' Fire ListChildren to display all the
   ' child windows in the ListBox
   ListChildWindows hWindow(lstWindows.ListIndex)
End Sub


Private Sub cmdChild2_Click()
   ' Exit if No item is selected
   If lstChild.ListIndex = -1 Then
      MsgBox "Please select a window first!", vbExclamation, "Sorry"
      Exit Sub
   End If
   
   ' Fire ListChildWindows to display all the
   ' child windows in the ListBox
   ListChildWindows hChild(lstChild.ListIndex)
End Sub

Private Sub cmdReload_Click()
   ' Declares
   #If Win32 Then
   Dim hWnd, i As Long
   Dim sPrefix, sWndText As String
   #Else
   Dim hWnd, i As Integer
   Dim sPrefix, sWndText As String
   #End If
   
   '
   ' Clear List Box
   lstWindows.Clear
   
   '
   ' Get Handle of First Window
   hWnd = GetWindow(Me.hWnd, GW_HWNDFIRST)
   
   '
   ' Loop, adding windows which window
   ' text isn't nothing
   '
   While hWnd
      ' Get the Window's text
      sWndText = WindowText(hWnd)
      
      ' Add the Window Text only if it isn't ""
      If sWndText <> "" Then
         lstWindows.AddItem sWndText
         
         ' Add handle of window to array,
         ' then incrament counter
         hWindow(i) = hWnd
         i = i + 1
      End If
      
      ' Get next Window
      hWnd = GetWindow(hWnd, GW_HWNDNEXT)
   Wend
End Sub

Private Sub Form_Load()
   ' Center Me
   CenterForm Me
   
   ' Set height
   Me.Height = 2650
   
   ' Load windows
   cmdReload_Click
End Sub


Private Sub Form_Paint()
   ' Draw 3d Line
   Line3D lnSep
End Sub


Private Sub Form_Unload(Cancel As Integer)
   frmMain.Show
End Sub


Private Sub lstChild_Click()
   ' Determine whether the current item has Children,
   ' if it does - Enable the button
   cmdChild2.Enabled = CBool(GetChildCount(hChild(lstChild.ListIndex)))
End Sub


Private Sub lstWindows_Click()
   ' Determine whether the current item has Children,
   ' if it does - Enable the button
   cmdChild.Enabled = CBool(GetChildCount(hWindow(lstWindows.ListIndex)))
End Sub


