VERSION 2.00
Begin Form WinSeek 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Find It"
   ClientHeight    =   5295
   ClientLeft      =   2655
   ClientTop       =   975
   ClientWidth     =   5400
   ForeColor       =   &H00000080&
   Height          =   5700
   Left            =   2595
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5295
   ScaleWidth      =   5400
   Top             =   630
   Width           =   5520
   Begin CommandButton cmdHelp 
      BackColor       =   &H00C0C0C0&
      Caption         =   "&Help"
      Default         =   -1  'True
      Height          =   495
      Left            =   2160
      TabIndex        =   13
      Top             =   4680
      Width           =   1200
   End
   Begin CheckBox Check3 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Include Sub"
      Height          =   375
      Left            =   1920
      TabIndex        =   12
      Top             =   320
      Value           =   1  'Checked
      Width           =   1335
   End
   Begin ListBox lstFoundFiles 
      Height          =   1590
      Left            =   480
      TabIndex        =   9
      Top             =   3000
      Width           =   3375
   End
   Begin CheckBox Check2 
      BackColor       =   &H00C0C0C0&
      Caption         =   "System"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   360
      Width           =   975
   End
   Begin CheckBox Check1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Hidden"
      Height          =   375
      Left            =   120
      TabIndex        =   7
      Top             =   0
      Width           =   975
   End
   Begin DriveListBox drvList 
      Height          =   315
      Left            =   3360
      TabIndex        =   2
      Top             =   720
      Width           =   1575
   End
   Begin DirListBox dirList 
      Height          =   1605
      Left            =   3360
      TabIndex        =   6
      Top             =   1200
      Width           =   1575
   End
   Begin FileListBox filList 
      Height          =   2175
      Hidden          =   -1  'True
      Left            =   480
      System          =   -1  'True
      TabIndex        =   5
      Top             =   720
      Width           =   1815
   End
   Begin TextBox txtSearchSpec 
      Height          =   285
      Left            =   3360
      TabIndex        =   4
      Text            =   "*.*"
      Top             =   100
      Width           =   1575
   End
   Begin CommandButton cmdSearch 
      BackColor       =   &H00C0C0C0&
      Caption         =   "&Search"
      Height          =   495
      Left            =   480
      TabIndex        =   0
      Top             =   4680
      Width           =   1200
   End
   Begin CommandButton cmdExit 
      BackColor       =   &H00C0C0C0&
      Caption         =   "E&xit"
      Height          =   495
      Left            =   3720
      TabIndex        =   1
      Top             =   4680
      Width           =   1200
   End
   Begin Label lblfound 
      BackColor       =   &H00C0C0C0&
      Caption         =   "&Files Found:"
      Height          =   255
      Left            =   4080
      TabIndex        =   11
      Top             =   3240
      Width           =   1095
   End
   Begin Label lblCount 
      BackColor       =   &H00C0C0C0&
      Caption         =   "0"
      Height          =   255
      Left            =   4200
      TabIndex        =   10
      Top             =   3600
      Width           =   735
   End
   Begin Label lblCriteria 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Search &Criteria:"
      Height          =   255
      Left            =   1920
      TabIndex        =   3
      Top             =   100
      Width           =   1335
   End
End
Option Explicit

Dim SearchFlag As Integer    ' Used as flag for cancelling, etc.
Dim Attr, FName
Dim Msg

Const ATTR_READONLY = 1, ATTR_HIDDEN = 2    ' Declare constants.
Const ATTR_SYSTEM = 4, ATTR_ARCHIVE = 32

Sub cmdExit_Click ()

  If cmdExit.Caption = "E&xit" Then
    End
  Else                ' If Cancel, just end Search.
    SearchFlag = False
  End If

End Sub

Sub cmdHelp_Click ()

Help.Show 1

End Sub

Sub cmdSearch_Click ()

' Initialize for search, then call DirDiver to perform recursive search.
Dim FirstPath As String, DirCount As Integer, NumFiles As Integer
Dim result As Integer
  ' Check what the user did last:
  If cmdSearch.Caption = "&Reset" Then  ' If just a reset,
    ResetSearch                         ' initialize and exit.
    txtSearchSpec.SetFocus
    Exit Sub
  End If

  ' Update dirList.Path if it is different from the currently
  ' selected directory, otherwise perform the search.
  If dirList.Path <> dirList.List(dirList.ListIndex) Then
     dirList.Path = dirList.List(dirList.ListIndex)
     Exit Sub         ' Exit so user can take a look before searching.
  End If

  ' Continue with the search.
  'Picture2.Move 0, 0
  'Picture1.Visible = False
  'Picture2.Visible = True

  cmdExit.Caption = "Cancel"

  filList.Pattern = txtSearchSpec.Text
  FirstPath = dirList.Path
  DirCount = dirList.ListCount

  'Start recursive direcory search.
  NumFiles = 0                       ' Reset global foundfiles indicator.
  result = DirDiver(FirstPath, DirCount, "")
  filList.Path = dirList.Path
  cmdSearch.Caption = "&Reset"
  cmdSearch.SetFocus
  cmdExit.Caption = "E&xit"

End Sub

Function DirDiver (NewPath As String, DirCount As Integer, BackUp As String) As Integer
'  Recursively search directories from NewPath down...
'     NewPath is searched on this recursion.
'     BackUp is origin of this recursion.
'     DirCount is number of subdirectories in this directory.

Static FirstErr As Integer
Dim DirsToPeek As Integer, AbandonSearch As Integer, ind As Integer
Dim OldPath As String, ThePath As String, entry As String
Dim retval As Integer
  
  SearchFlag = True             ' Set flag so user can interrupt.
  DirDiver = False              ' Set to TRUE if there is an error.
  retval = DoEvents()           ' check for events (i.e. user Cancels).
  If SearchFlag = False Then
    DirDiver = True
    Exit Function
  End If
  On Local Error GoTo DirDriverHandler
  If Check3 Then
    DirsToPeek = dirList.ListCount            ' How many directories below this?
  Else
    DirsToPeek = 0            ' How many directories below this?
  End If
  Do While DirsToPeek > 0 And SearchFlag = True
    OldPath = dirList.Path                  ' Save old path for next recursion.
    dirList.Path = NewPath
    If dirList.ListCount > 0 Then
    ' Get to the node bottom.
      dirList.Path = dirList.List(DirsToPeek - 1)
      AbandonSearch = DirDiver((dirList.Path), DirCount%, OldPath)
    End If
    ' Go up 1 level in directories.
    DirsToPeek = DirsToPeek - 1
    If AbandonSearch = True Then Exit Function
  Loop
  ' Call function to enumerate files.
  If filList.ListCount Then
    If Len(dirList.Path) <= 3 Then
	ThePath = dirList.Path         ' If at root level, leave as is...
    Else
	ThePath = dirList.Path + "\"   ' otherwise put "\" before file name.
    End If
    For ind = 0 To filList.ListCount - 1        ' Add conforming files
	entry = ThePath + filList.List(ind)
	If Check1 Or Check2 Then
	    Attr = GetAttr(entry)   ' Get attributes.
	    If Attr > 7 Then Attr = Attr Xor ATTR_ARCHIVE
	End If
	If Check1 Then
	    If (Attr And 2) = 2 Then
		lstFoundFiles.AddItem entry
		lblCount.Caption = Str$(Val(lblCount.Caption) + 1)
	    End If
	ElseIf Check2 Then
	    If (Attr And 4) = 4 Then
		lstFoundFiles.AddItem entry
		lblCount.Caption = Str$(Val(lblCount.Caption) + 1)
	    End If
	Else
	    lstFoundFiles.AddItem entry
	    lblCount.Caption = Str$(Val(lblCount.Caption) + 1)
	End If
    Next ind
  End If
  If BackUp <> "" Then         ' If there is a superior
      dirList.Path = BackUp    ' directory, move to it.
  End If
  Exit Function
DirDriverHandler:
  If Err = 7 Then         ' If Out of Memory, assume listbox just got full.
    DirDiver = True       ' Create Msg$ and set return value AbandonSearch.
    MsgBox "You've filled the listbox. Search being abandoned..."
    Exit Function         ' Note that EXIT procedure resets ERR to 0.
  Else                    ' Otherwise display error message and quit.
    MsgBox Error
    End
  End If

End Function

Sub DirList_Change ()

    ' Update File listbox to sync with Dir listbox.
    filList.Path = dirList.Path

End Sub

Sub DirList_LostFocus ()

    dirList.Path = dirList.List(dirList.ListIndex)

End Sub

Sub DrvList_Change ()
    
    On Error GoTo DriveHandler
    dirList.Path = drvList.Drive
    Exit Sub

DriveHandler:
    drvList.Drive = dirList.Path
    Exit Sub

End Sub

Sub filList_DblClick ()

    If Right(dirList.Path, 1) = "\" Then ' See if root file.
	FName = dirList.Path & filList.FileName  ' Get file path.
    Else
	FName = dirList.Path & "\" & filList.FileName    ' Get file path.
    End If
    Attr = GetAttr(FName)   ' Get attributes.
    If Attr > 7 Then Attr = Attr Xor ATTR_ARCHIVE   ' Disregard Archive
    Select Case Attr    ' Look up attributes.
	Case 0: Msg = "Normal"

	Case ATTR_READONLY: Msg = "Read-Only"
	Case ATTR_HIDDEN: Msg = "Hidden"
	Case ATTR_HIDDEN + ATTR_READONLY: Msg = "Hidden and Read-Only"
	Case ATTR_SYSTEM: Msg = "System"
	Case ATTR_READONLY + ATTR_SYSTEM: Msg = "Read-Only and System"
	Case ATTR_HIDDEN + ATTR_SYSTEM: Msg = "Hidden and System"
	Case ATTR_READONLY + ATTR_HIDDEN + ATTR_SYSTEM: Msg = "Read-Only, Hidden, and System"
    End Select
    MsgBox UCase(FName) & " is a " & Msg & " file." ' Display message.

End Sub

Sub Form_Unload (Cancel As Integer)
    
    End

End Sub

Sub lstFoundFiles_DblClick ()

    FName = lstFoundFiles
    Attr = GetAttr(FName)   ' Get attributes.
    If Attr > 7 Then Attr = Attr Xor ATTR_ARCHIVE   ' Disregard Archive
    Select Case Attr    ' Look up attributes.
	Case 0: Msg = "Normal"

	Case ATTR_READONLY: Msg = "Read-Only"
	Case ATTR_HIDDEN: Msg = "Hidden"
	Case ATTR_HIDDEN + ATTR_READONLY: Msg = "Hidden and Read-Only"
	Case ATTR_SYSTEM: Msg = "System"
	Case ATTR_READONLY + ATTR_SYSTEM: Msg = "Read-Only and System"
	Case ATTR_HIDDEN + ATTR_SYSTEM: Msg = "Hidden and System"
	Case ATTR_READONLY + ATTR_HIDDEN + ATTR_SYSTEM: Msg = "Read-Only, Hidden, and System"
    End Select
    MsgBox UCase(FName) & " is a " & Msg & " file." ' Display message.

End Sub

Sub ResetSearch ()
' Reinitialize before starting a new search.
    lstFoundFiles.Clear
    lblCount.Caption = 0
    SearchFlag = False                  ' Flag indicating search in progress.
    cmdSearch.Caption = "&Search"
    cmdExit.Caption = "E&xit"
    dirList.Path = CurDir$: drvList.Drive = dirList.Path ' Reset DOS path.
End Sub

