'PKSAVR by Paul Kolbert 2-95

Option Explicit

'API Declarations
'routines for reading data in 'CONTROL.INI'

Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function GetPrivateProfileInt Lib "KERNEL" (ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal nDefault As Integer, ByVal lpszFileName As String) As Integer
Declare Function WritePrivateProfileString Lib "KERNEL" (ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal nString As String, ByVal lpszFileName As String) As Integer

'API to Show and Hide Mouse
Declare Function ShowCursor Lib "USER" (ByVal fShow As Integer) As Integer

'
'constants for control.ini file
'needed to setup saver


Global Your_BMP As String     ' the bmp file

Global Const iniName = "CONTROL.INI"
Global Const secName = "Screen Saver.AOLSAVR"  ' your savername here
Global Const FileName = "Your_BMP"


' API routines for capturing screen
Declare Sub BitBlt Lib "GDI" (ByVal DestDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal BWidth As Integer, ByVal BHeight As Integer, ByVal SourceDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal Constant As Long)
Declare Function CreateDC Lib "GDI" (ByVal Driver As Any, ByVal Dev As Any, ByVal O As Any, ByVal Init As Any) As Integer
Declare Sub DeleteDC Lib "GDI" (ByVal hDC As Integer)
Declare Function GetDeviceCaps Lib "GDI" (ByVal hDC As Integer, ByVal nIndex As Integer) As Integer

' variables and constants to be used for screen capture
' if you want to use the last screen instead of your bmp

Global ScrnW As Integer, ScrnH As Integer
Global Const HORZRES = 8
Global Const VERTRES = 10

Sub EndSavr ()
    ShowMouse                   ' Make mouse pointer visible again
    End                         ' And exit
End Sub

Function GetFromINI (AppName$, KeyName$, FileName$) As String
   Dim RetStr As String
   RetStr = String(255, Chr(0))
   GetFromINI = Left(RetStr, GetPrivateProfileString(AppName$, ByVal KeyName$, "", RetStr, Len(RetStr), FileName$))
End Function

Sub HideMouse ()
    While ShowCursor(False) >= 0 '(false)
    Wend
End Sub

Sub Main ()
    
    Dim i As Integer
    Dim DC As Integer

    'Is this the only copy running?  Windows will call
    'the program evry time the interval is reached if this line is absent!
    If App.PrevInstance Then End
    
    ' see readme.wri  for discussion!
    If InStr(Command$, "/c") Then
         SetupFrm.Show 1
                     
    ElseIf InStr(Command$, "/s") Then
        TheSavrScrn.Show
    End If

    
    '
    ' Wait until there are no form visible, then quit.
    '
    While DoEvents() > 0    ' Loop until no forms visible
    Wend
End Sub

Sub ShowMouse ()
    While ShowCursor(True) < 0
    Wend
End Sub

