VERSION 2.00
Begin Form PMGroupList 
   Caption         =   "Form1"
   ClientHeight    =   2805
   ClientLeft      =   1200
   ClientTop       =   3015
   ClientWidth     =   7365
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   Height          =   3210
   Left            =   1140
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2805
   ScaleWidth      =   7365
   Top             =   2670
   Width           =   7485
   Begin CommandButton BtnCreate 
      Caption         =   "Create"
      Height          =   495
      Left            =   5715
      TabIndex        =   3
      Top             =   1800
      Width           =   1215
   End
   Begin CommandButton BtnOK 
      Caption         =   "OK"
      Height          =   495
      Left            =   5715
      TabIndex        =   2
      Top             =   1200
      Width           =   1215
   End
   Begin ListBox LstGroups 
      Height          =   1590
      Left            =   2310
      TabIndex        =   1
      Top             =   915
      Width           =   2760
   End
   Begin Label Label1 
      Caption         =   "Label1"
      Height          =   825
      Left            =   165
      TabIndex        =   0
      Top             =   60
      Width           =   7035
   End
End
Dim mlblDDELink  As label

Sub BtnCreate_Click ()
    Dim GroupPath As String
    GroupName = ""  'Set GroupName to an empty string
    
    'Get the name of the new group
    Msg$ = "Enter the name of the new Program Manager group you want " + APPNAME + " placed in."
    
    'Make sure the user doesn't press enter by mistake before typing something
    While GroupName = ""
        GroupName = InputBox$(Msg$, APPNAME + " Setup")
    Wend
    
    'Make sure the group does not already exist
    'If it does, simply exit the sub and continue
    For I = 0 To LstGroups.ListCount - 1
        If GroupName = LstGroups.List(I) Then
            Unload PMGroupList
            Exit Sub
        End If
    Next I
    
    'Truncate the name of the group to the first 8 characters
    'and add the .grp extension for the file name of the group
    GroupPath = Trim$(Left$(GroupName, 8)) + ".GRP"
    
    'Make sure the new group filename does not already exist
    I = 0
    Do While FileExists(WinDir$ + GroupPath)
        'If it does exist, truncate to 7 characters, append the value of I to
        'the filename and increment I each time the check fails.  It's not likely
        'this loop will need to be executed more than once, but better safe than sorry
        GroupPath = Left$(GroupName, 7) + Trim$(Str(I)) + ".GRP"
        I = I + 1
    Loop    'Repeat until filename doesn't exist

    'call the routine to create the new PM group
    CreateProgManGroup Setup1, GroupName, GroupPath
    
    Unload PMGroupList
End Sub

Sub BtnOK_Click ()
    'Get the name of the group selected from the list box
    GroupName = LstGroups.List(LstGroups.ListIndex)
    
    'If the user pressed enter without selecting a group, say so.
    'This is not really necessary as far as the setup program is
    'concerned, since it will default to whatever group is the
    'currently active one, but the user might not realize where
    'the icon was created and become confused.
    If GroupName = "" Then
        MsgBox "Please select a Program Manager group or click the Create button.", , APPNAME + " Setup"
        Exit Sub
    End If
    Unload PMGroupList
End Sub

Sub Form_Load ()
    Set mlblDDELink = PMGroupList!Label1
    Dim I%
    Dim GetGroups%
    ReDim arrGroups$(0)
    
    CenterForm PMGroupList

    'Get a list of all PM groups
    GetGroups% = ddepmGetGroups(mlblDDELink, arrGroups$())
    
    'Add all PM groups to the listbox
    LstGroups.Clear
    For I% = 0 To UBound(arrGroups$)
        LstGroups.AddItem arrGroups$(I%)
    Next I%
    
    'Provide instructions to the user.  Define msg$ for whatever is appropriate
    'for your application.
    Msg$ = "Select the Program Manager group you would like " + APPNAME + " located in then click OK.  "
    Msg$ = Msg$ + "If you wish to create a new group, click the Create button.  It is recommended that "
    Msg$ = Msg$ + APPNAME + " be placed in the Startup group."
    Label1.Caption = Msg$

    'Set the title bar caption appropriately
    PMGroupList.Caption = APPNAME + " Setup"
    
End Sub

