VERSION 2.00
Begin Form TheSavrScrn 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   ClientHeight    =   2565
   ClientLeft      =   930
   ClientTop       =   1605
   ClientWidth     =   5715
   ControlBox      =   0   'False
   Height          =   2970
   Left            =   870
   LinkTopic       =   "Form1"
   ScaleHeight     =   171
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   381
   Top             =   1260
   Width           =   5835
   Begin Timer Tick 
      Interval        =   50
      Left            =   0
      Top             =   15
   End
End
' TheSavrScrn -- the background picture

Option Explicit



Dim i As Integer
Dim DC As Integer
Dim LastX, LastY            ' Last position of the mouse

'variables for "Roll routine from Manythings"
Dim PlotInit As Integer
Dim x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer
Dim vx1 As Single, vy1 As Single, vx2 As Single, vy2 As Single
Dim ax1 As Single, ax2 As Single, ay1 As Single, ay2 As Single
Dim MaxSpeedX As Integer, MaxSpeedY As Integer
Dim Direction As Integer

Sub Form_Activate ()

    ' first capture screen into Form 'BasePic' for later use
    
    DC = CreateDC("DISPLAY", 0&, 0&, 0&)
    ScrnW = GetDeviceCaps(DC, HORZRES)
    ScrnH = GetDeviceCaps(DC, VERTRES)
    BitBlt BasePic.hDC, 0, 0, ScrnW, ScrnH, DC, 0, 0, &HCC0020
    DeleteDC DC


End Sub

Sub Form_KeyDown (KeyCode As Integer, Shift As Integer)
    
    EndSavr

End Sub

Sub Form_Load ()

    ' stretch to full screen
    Move 0, 0, screen.Width, screen.Height
    
    '********************************************
' GetFromIni assumes contol.ini is in Windows directory or:
'ininame = app.Path + "\control.ini"
picture = LoadPicture(GetFromINI("Screen Saver.AOLSAVR", "Your_BMP", ininame))
    
    HideMouse
    
End Sub

Sub Form_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)

EndSavr

End Sub

Sub Form_MouseMove (Button As Integer, Shift As Integer, X As Single, Y As Single)
   
Const Pixel_Move = 3

'traps stray VB mouse_moves
If LastX = 0 Or LastY = 0 Then
  LastX = X
  LastY = Y
  Exit Sub
End If

'tests for a real mouse_move!
If Abs(LastX - X) > Pixel_Move Then EndSavr
If Abs(LastY - Y) > Pixel_Move Then EndSavr

LastX = X                   ' If not a "real" move,
LastY = Y                   '  update position




End Sub

Sub Tick_Timer ()
   
   ' the timer is used here because you can use another
   ' saver routine, called at specific intervals
   
   YourSavrRoutine

End Sub

Sub YourSavrRoutine ()

' place your routine here
'in other words, put a picture here and
'make it do something to save the screen!
' this routine borrowed from manythings.scr, freeware available on AOL

  Dim v As Integer
  ' if first time, initialize the picture and speeds, etc
 If PlotInit = False Then
    
    'to start with BasePic screen, use this capture routine:
    'picture = BasePic.Image
     
     'to load your own bmp embedded in the program, use:
     'picture = LoadPicture("c:\windows\your.bmp")
    
    'to load a picture from the setup, as listed in the ini:
    picture = LoadPicture(GetFromINI("Screen Saver.AOLSAVR", "Your_BMP", ininame))
    PlotInit = True

    'Calculate velocity limits
    MaxSpeedX = ScaleWidth * 15! / 800
    MaxSpeedY = ScaleWidth * 15! / 600

    ' initial velocities
    vy1 = 0: vx1 = 0

    ' initial offset
    x1 = 0: y1 = 0

    Direction = Rnd * 2: If Direction > 1 Then Direction = 0

   Else
       
    ' no need to reinitialize, so begin the work!

    DC = BasePic.hDC

    If Direction Then
        ' do vertical scroll
        BitBlt hDC, 0, y1, ScaleWidth, ScaleHeight - y1, DC, 0, 0, &HCC0020
        BitBlt hDC, 0, 0, ScaleWidth, y1, DC, 0, ScaleHeight - y1, &HCC0020
    Else
        ' do horizontal scroll
        BitBlt hDC, x1, 0, ScaleWidth - x1, ScaleHeight, DC, 0, 0, &HCC0020
        BitBlt hDC, 0, 0, x1, ScaleHeight, DC, ScaleWidth - x1, 0, &HCC0020
    End If

    'determine new acceleration
    ax1 = Rnd - .5
    ay1 = Rnd - .5
            
    'calculate new velocity
    vx1 = (vx1 + ax1): If Abs(vx1) > MaxSpeedX Then vx1 = 0: ax1 = 0
    vy1 = (vy1 + ay1): If Abs(vy1) > MaxSpeedY Then vy1 = 0: ay1 = 0

    'find new roll amount
    x1 = x1 + vx1
    If x1 > ScaleWidth Then
        x1 = x1 - ScaleWidth
    Else
        If x1 < 0 Then
            x1 = x1 + ScaleWidth
        End If
    End If
            
    y1 = y1 + vy1
    If y1 > ScaleHeight Then
        y1 = y1 - ScaleHeight
    Else
        If y1 < 0 Then
            y1 = y1 + ScaleHeight
        End If
    End If
            
  End If

End Sub

