VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   5715
   ClientLeft      =   1980
   ClientTop       =   1965
   ClientWidth     =   6585
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   5715
   ScaleWidth      =   6585
   Begin VB.OptionButton Option1 
      Caption         =   "Option3"
      Height          =   495
      Index           =   2
      Left            =   5085
      TabIndex        =   8
      Top             =   3195
      Width           =   1215
   End
   Begin VB.OptionButton Option1 
      Caption         =   "Option2"
      Height          =   495
      Index           =   1
      Left            =   5085
      TabIndex        =   7
      Top             =   2505
      Width           =   1215
   End
   Begin VB.OptionButton Option1 
      Caption         =   "Option1"
      Height          =   495
      Index           =   0
      Left            =   5085
      TabIndex        =   6
      Top             =   1815
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Sounds are on"
      Height          =   495
      Index           =   0
      Left            =   1785
      TabIndex        =   5
      Top             =   2280
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command5"
      Height          =   495
      Index           =   4
      Left            =   1785
      TabIndex        =   4
      Top             =   4980
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command4"
      Height          =   495
      Index           =   3
      Left            =   1785
      TabIndex        =   3
      Top             =   4335
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command3"
      Height          =   495
      Index           =   2
      Left            =   1785
      TabIndex        =   2
      Top             =   3690
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Close"
      Height          =   495
      Index           =   1
      Left            =   1785
      TabIndex        =   1
      Top             =   2940
      Width           =   1215
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      BorderStyle     =   1  'Fixed Single
      Caption         =   $"frmMain.frx":0000
      Height          =   1815
      Left            =   1605
      TabIndex        =   0
      Top             =   90
      Width           =   2955
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Sounds As New clsSound

'Sound that is specific to the application.
'Index these in the resource file from 100 to 199
Const SS_HELP_ME = 100

Private Sub Command1_Click(Index As Integer)

Select Case Index
    Case 0
        'Enable or disable sounds
        Sounds.Enabled = Not Sounds.Enabled
        Select Case Sounds.Enabled
            Case True
                Command1(0).Caption = "Sounds are on"
            Case Else
                Command1(0).Caption = "Sounds are off"
        End Select
    Case 1
        'Unload the form to end the program.
        'Do NOT use the End statement because this may
        'not free up resources used by the class.
        Unload Me
End Select

End Sub


Private Sub Command1_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

Sounds.BeginPlaySound ssButtonClick

End Sub


Private Sub Form_Load()


Sounds.BeginPlaySound ssStartUp, , True

'Set the command button's caption appropriately
Select Case Sounds.Enabled
    Case True
        Command1(0).Caption = "Sounds are on"
    Case False
        Command1(0).Caption = "Sounds are off"
End Select

End Sub


Private Sub Form_Unload(Cancel As Integer)

'Play this sound synchronously so control does not
'return until the sound has finished.  It will also
'play even if Sounds.Enabled = False.
Sounds.BeginPlaySound ssShutDown, ssSndSync, True

'Very important to free up resources used by the class.
Set Sounds = Nothing

End Sub



Private Sub Label1_Click()

Static bIsPlaying As Boolean

'Loops the sound until the form is clicked a 2nd time.
'This REQUIRES that the sound sound be played
'asynchronously; otherwise, control would never return
'to the calling procedure.  Since the BeginPlaySound method
'automatically accounts for this, it is NOT necessary
'to specify the ssSndAsync constant, although you still can
'if you want to.  It won't hurt anything.  The optional
'Override argument is also set to True, so this sound will
'play even if the Sounds.Enabled property is False.

If Not bIsPlaying Then
    Sounds.BeginPlaySound SS_HELP_ME, ssSndAsync Or ssSndLoop, True
Else
    Sounds.EndPlaySound
End If

bIsPlaying = Not bIsPlaying

End Sub

Private Sub Option1_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

Sounds.BeginPlaySound ssOptionClick

End Sub


