VERSION 2.00
Begin Form frmMain 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Printing Demo"
   ClientHeight    =   4020
   ClientLeft      =   510
   ClientTop       =   2430
   ClientWidth     =   8895
   Height          =   4425
   Left            =   450
   LinkTopic       =   "Form1"
   ScaleHeight     =   4020
   ScaleWidth      =   8895
   Top             =   2085
   Width           =   9015
   Begin CommandButton Command6 
      Caption         =   "Personal Info"
      Height          =   495
      Left            =   3240
      TabIndex        =   13
      Top             =   1440
      Width           =   1215
   End
   Begin CheckBox HorGridlines 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Horizontal gridlines"
      Height          =   495
      Left            =   6360
      TabIndex        =   12
      Top             =   510
      Value           =   1  'Checked
      Width           =   2220
   End
   Begin CheckBox VertGridlines 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Vertical gridlines"
      Height          =   495
      Left            =   6360
      TabIndex        =   11
      Top             =   120
      Value           =   1  'Checked
      Width           =   2130
   End
   Begin CommandButton Command5 
      Caption         =   "Exit"
      Height          =   495
      Left            =   7560
      TabIndex        =   10
      Top             =   1440
      Width           =   1215
   End
   Begin CommandButton Command4 
      Caption         =   "Font Setup"
      Height          =   495
      Left            =   1785
      TabIndex        =   9
      Top             =   1440
      Width           =   1215
   End
   Begin CommandButton Command3 
      Caption         =   "Printer Setup"
      Height          =   495
      Left            =   240
      TabIndex        =   8
      Top             =   1440
      Width           =   1320
   End
   Begin OptionButton PrintWithLayout 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Print grid with page layout"
      Height          =   495
      Left            =   3240
      TabIndex        =   7
      Top             =   555
      Width           =   2880
   End
   Begin OptionButton PrintJustGrid 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Print just grid"
      Height          =   495
      Left            =   3240
      TabIndex        =   6
      Top             =   120
      Value           =   -1  'True
      Width           =   2760
   End
   Begin CommandButton Command2 
      Caption         =   "Print Grid"
      Enabled         =   0   'False
      Height          =   495
      Left            =   6120
      TabIndex        =   5
      Top             =   1440
      Width           =   1215
   End
   Begin CommandButton Command1 
      Caption         =   "Fill Grid"
      Height          =   495
      Left            =   4680
      TabIndex        =   4
      Top             =   1440
      Width           =   1185
   End
   Begin CommonDialog dlog 
      Left            =   3165
      Top             =   2535
   End
   Begin HScrollBar HScroll1 
      Height          =   270
      LargeChange     =   100
      Left            =   240
      Max             =   1000
      Min             =   10
      SmallChange     =   10
      TabIndex        =   1
      Top             =   960
      Value           =   10
      Width           =   2175
   End
   Begin Grid Grid1 
      FixedCols       =   0
      Height          =   495
      Left            =   0
      TabIndex        =   0
      Top             =   2115
      Visible         =   0   'False
      Width           =   1215
   End
   Begin Label lblNumberOfRows 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackColor       =   &H00C0C0C0&
      Caption         =   "10"
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   12
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   300
      Left            =   810
      TabIndex        =   3
      Top             =   465
      Width           =   330
   End
   Begin Label Label1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Number of rows in the grid:"
      Height          =   285
      Left            =   60
      TabIndex        =   2
      Top             =   75
      Width           =   2325
   End
End

Sub Command1_Click ()
Command2.Enabled = True
NumberOfRows = HScroll1.Value
FillGrid frmMain.Grid1
End Sub

Sub Command2_Click ()
If PrintWithLayout.Value = True Then
fPrintLayout = True
Else
fPrintLayout = False
End If

If VertGridlines.Value = 1 Then
fPrintVertGridlines = True
Else
fPrintVertGridlines = False
End If

If HorGridlines.Value = 1 Then
fPrintHorGridlines = True
Else
fPrintHorGridlines = False
End If
PrintGrid frmMain.Grid1
End Sub

Sub Command3_Click ()
PrinterSetup
End Sub

Sub Command4_Click ()
FontSetup
End Sub

Sub Command5_Click ()
On Error Resume Next
End
End Sub

Sub Command6_Click ()
frmPersonalInfo.Show 1
End Sub

Sub Form_Load ()
Dim I As Integer

If frmMain.WindowState <> 1 Then
CenterForm Me
Grid1.Width = Abs(frmMain.Width - Grid1.Left - 240)
Grid1.Height = Abs(frmMain.Height - Grid1.Top - 650)
End If
NumberOfRows = 2
Grid1.Cols = 4
Grid1.Row = 0
Grid1.Col = 0
Grid1.Text = "First Column Header"
Grid1.Col = 1
Grid1.Text = "Second Column Header"
Grid1.Col = 2
Grid1.Text = "Third Column Header"
Grid1.Col = 3
Grid1.Text = "Fourth Column Header"
For I = 0 To 3
Grid1.Col = I
Grid1.ColWidth(I) = frmMain.TextWidth(Grid1.Text) + 100
Next I
End Sub

Sub Form_QueryUnload (Cancel As Integer, UnloadMode As Integer)
On Error Resume Next
End Sub

Sub Form_Resize ()
If frmMain.WindowState <> 1 Then
Grid1.Width = Abs(frmMain.Width - Grid1.Left - 240)
Grid1.Height = Abs(frmMain.Height - Grid1.Top - 650)
End If

End Sub

Sub Form_Unload (Cancel As Integer)
On Error Resume Next
End Sub

Sub HScroll1_Change ()
lblNumberOfRows.Caption = HScroll1.Value
NumberOfRows = HScroll1.Value
End Sub

